gpar = eout=1 gainpanel=e newclip=1 bclip=-10. eclip=10.
cpar = point1=0.8 point2=0.8 screenratio=0.5 titlefat=2 titlesz=14 wheretitle=t wantcoordlabel=-1 label1='z(m)' label2='x(m)' label3='hx(m)' labelsz=5 >/dev/null
Fig/dmDei5.v:
	python ~/Setup/pyRemove.py tmp1.H
	Transp < Data/dmDei5iter1Mask.H  plane=34 | Grey ${gpar} > tmp1.H
	Cubeplot < tmp1.H esize=1 frame1=100 frame2=130 frame3=31 title='(a)'  ${cpar} wantaxes1=n  out=junk1.v >/dev/null
	Cubeplot < tmp1.H esize=1 frame1=100 frame2=166 frame3=31 title='(b)'  ${cpar} wantaxes1=n  out=junk2.v >/dev/null
	Cubeplot < tmp1.H esize=1 frame1=100 frame2=202 frame3=31 title='(c)'  ${cpar}  out=junk3.v >/dev/null
	vppen < junk1.v vpstyle=n xshift=0 yshift=20.5 > 1.v
	vppen < junk2.v vpstyle=n xshift=0 yshift=10.5 > 2.v
	vppen < junk3.v vpstyle=n xshift=0 yshift=0.5 > 3.v
	vppen 1.v 2.v 3.v erase=n scale=0.2 > $@
	python pycode/pyRemove.py 1.v 2.v 3.v junk*.v
	
Fig/filtdmDei5.v:
	python ~/Setup/pyRemove.py tmp1.H tmp2.H tmp3.H
	Transp < Data/dmDei5iter1Mask.H  plane=34 | Grey ${gpar} > tmp1.H
	Transp < Data/dmDei5NSafter.H  plane=34 | Grey ${gpar} > tmp2.H
	Transp < Data/dmDei5NSafter2.H  plane=34 | Grey ${gpar} > tmp3.H
	Cubeplot < tmp1.H esize=1 frame1=100 frame2=190 frame3=31 title='(a)'  ${cpar} wantaxes1=n  out=junk1.v >/dev/null
	Cubeplot < tmp2.H esize=1 frame1=100 frame2=190 frame3=31 title='(b)'  ${cpar} wantaxes1=n  out=junk2.v >/dev/null
	Cubeplot < tmp3.H esize=1 frame1=100 frame2=190 frame3=31 title='(c)'  ${cpar}  out=junk3.v >/dev/null
	vppen < junk1.v vpstyle=n xshift=0 yshift=20.5 > 1.v
	vppen < junk2.v vpstyle=n xshift=0 yshift=10.5 > 2.v
	vppen < junk3.v vpstyle=n xshift=0 yshift=0.5 > 3.v
	vppen 1.v 2.v 3.v erase=n scale=0.2 > $@
	python pycode/pyRemove.py 1.v 2.v 3.v junk*.v	
	python ~/Setup/pyRemove.py tmp1.H tmp2.H tmp3.H
	
Winpar = Window3d n1=100 f1=36 | Window3d n2=100 f2=100 | Interp d1out=12.5
gpar2 = screenratio=1. titlefat=2 titlesz=14 wheretitle=t wantcoordlabel=-1 wherexlabel=b label1='z(m)' label2='x(m)' label3='hx(m)' labelsz=9 >/dev/null
Fig/zoomfiltdmDei5.v:
#	python ~/Setup/pyRemove.py tmp1.H tmp2.H tmp3.H
	Window3d < Data/dmDei5iter1Mask.H  n4=1 f4=31 | ${Winpar} > tmp1.H	
	Window3d < Data/dmDei5NSafter.H  n4=1 f4=31 | ${Winpar}   > tmp2.H
	Window3d < Data/dmDei5NSafter2.H  n4=1 f4=31 | ${Winpar}  > tmp3.H	
	< tmp1.H Grey title='(a)'  ${gpar2} newclip=1 bclip=-2. eclip=2. out=junk1.v 
	< tmp2.H Grey title='(b)' ${gpar2} newclip=1 bclip=-2. eclip=2. wantaxis1=n out=junk2.v
	< tmp3.H Grey title='(c)' ${gpar2} newclip=1 bclip=-2. eclip=2. wantaxis1=n out=junk3.v
	vppen < junk1.v vpstyle=n xshift=0.5 yshift=0.5 > 1.v
	vppen < junk2.v vpstyle=n xshift=8.5 yshift=0.5 > 2.v
	vppen < junk3.v vpstyle=n xshift=16.5 yshift=0.5 > 3.v
	vppen 1.v 2.v 3.v erase=n scale=0.2 > $@
	python pycode/pyRemove.py 1.v 2.v 3.v junk*.v	
	python ~/Setup/pyRemove.py tmp1.H tmp2.H tmp3.H

########### Pre-processing ###########################################	
cpar2 = point1=0.8 point2=0.8 screenratio=0.8 titlefat=2 titlesz=14 wheretitle=t wantcoordlabel=-1 label1='z(m)' label2='x(m)' label3='y(m)' labelsz=5 >/dev/null
Fig/veldeimos.v: Input/velDeimos3D.H
	python ~/Setup/pyRemove.py tmp1.H 
	< Input/velDeimos3D.H Grey eout=1 pclip=100. newclip=1 > tmp1.H
	Cubeplot < tmp1.H esize=1 frame1=180 frame2=317 frame3=14 title=' ' gainpanel=a  ${cpar2} newclip=1 color=j out=$@ >/dev/null
	python ~/Setup/pyRemove.py tmp1.H 

gpar3 = screenratio=2. titlefat=2 titlesz=14 wheretitle=t wantcoordlabel=-1 wherexlabel=b label1='z(m)' label2='x(m)' labelsz=9 >/dev/null
Fig/datadeimos.v:
	python ~/Setup/pyRemove.py tmp1.H tmp2.H
	Window3d < ${deidir}/Data/NodeUp5.H n3=1 f3=10 | Bandpass fhi=20. > tmp1.H
	Window3d < ${deidir}/Data/NodeDn5.H n3=1 f3=10 | Bandpass fhi=20. > tmp2.H
	< tmp1.H Grey title='(a)'  ${gpar3} out=junk1.v 
	< tmp2.H Grey title='(b)' ${gpar3}  wantaxis1=n out=junk2.v
	vppen < junk1.v vpstyle=n xshift=0.5 yshift=0.5 > 1.v
	vppen < junk2.v vpstyle=n xshift=5.5 yshift=0.5 > 2.v
	vppen 1.v 2.v erase=n scale=0.2 > $@
	python pycode/pyRemove.py 1.v 2.v junk*.v	
	python ~/Setup/pyRemove.py tmp1.H tmp2.H
	
########### Image files ###########################################	
cpar3 = point1=0.8 point2=0.8 screenratio=0.8 titlefat=2 titlesz=14 wheretitle=t wantcoordlabel=-1 label1='z(m)' label2='x(m)' label3='hx(m)' labelsz=5 >/dev/null
Fig/xtalkdeimos.v:
	Bin/SecondDer3D.x < Data/rtmDeiGTotal.H VDer=1 | Transp   plane=34 | Interp d1out=12.5 | Grey ${gpar} > tmp1.H
	< Data/mDeiIInterpiter2.H Transp   plane=34 | Grey ${gpar} > tmp2.H
	Cubeplot < tmp1.H esize=1 frame1=100 frame2=190 frame3=31 title='(a)'  ${cpar} wantaxes1=n  out=junk1.v >/dev/null
	Cubeplot < tmp2.H esize=1 frame1=100 frame2=190 frame3=31 title='(b)'  ${cpar}  out=junk2.v >/dev/null
	vppen < junk1.v vpstyle=n xshift=0 yshift=10.5 > 1.v
	vppen < junk2.v vpstyle=n xshift=0 yshift=0.5 > 2.v
	vppen 1.v 2.v erase=n scale=0.2 > Fig/temp1.v
	python ~/Setup/pyRemove.py tmp1.H tmp2.H 
	vp_annotate < Fig/temp1.v text=Ant/antpanel1.txt batch=y > $@
	python pycode/pyRemove.py 1.v 2.v  junk*.v Fig/temp1.v	

gpar4 = eout=1 gainpanel=a 
Fig/updownimagedeimos.v:
	python ~/Setup/pyRemove.py tmp1.H tmp2.H
	Transp < Data/mDeiHbInterpiter2.H  plane=34 | Grey ${gpar4} pclip=95. > tmp1.H
	Transp < Data/mDeiIInterpiter2.H  plane=34 | Grey ${gpar4} pclip=92. > tmp2.H
	Cubeplot < tmp1.H esize=1 frame1=100 frame2=190 frame3=31 title='(a)'  ${cpar} reverse2=y wantaxes1=n  out=junk1.v >/dev/null
	Cubeplot < tmp2.H esize=1 frame1=100 frame2=190 frame3=31 title='(b)'  ${cpar}  out=junk2.v >/dev/null
	vppen < junk1.v vpstyle=n xshift=0 yshift=10.5 > 1.v
	vppen < junk2.v vpstyle=n xshift=0 yshift=0.5 > 2.v
	vppen 1.v 2.v erase=n scale=0.2 > $@
	python pycode/pyRemove.py 1.v 2.v  junk*.v	
	python ~/Setup/pyRemove.py tmp1.H tmp2.H 


gpar5 = eout=1 gainpanel=a pclip=99.
Fig/updownangdeimos.v: Data/mDeiHbAngiter2.H Data/mDeiIAngiter2.H
	python ~/Setup/pyRemove.py tmp1.H tmp2.H
	< Data/mDeiHbAngiter2.H  Window n3=1 f3=14 | Grey ${gpar5} > tmp1.H
	< Data/mDeiIAngiter2.H   Window n3=1 f3=14 | Grey ${gpar5} > tmp2.H
	Cubeplot < tmp1.H esize=1 frame1=100 frame2=290 frame3=31 title='(a)'  ${cpar} wantaxes1=n  out=junk1.v >/dev/null
	Cubeplot < tmp2.H esize=1 frame1=100 frame2=290 frame3=31 title='(b)'  ${cpar}  out=junk2.v >/dev/null
	vppen < junk1.v vpstyle=n xshift=0 yshift=10.5 > 1.v
	vppen < junk2.v vpstyle=n xshift=0 yshift=0.5 > 2.v
	vppen 1.v 2.v erase=n scale=0.2 > $@
	python pycode/pyRemove.py 1.v 2.v  junk*.v	
#	python ~/Setup/pyRemove.py tmp1.H tmp2.H 

gpar6 = eout=1 gainpanel=a pclip=96.
Fig/jointimagedeimos.v:
	python ~/Setup/pyRemove.py tmp1.H tmp2.H
	Transp < Data/mDeiJInterpiter2.H  plane=34 | Grey ${gpar6} > tmp1.H
	Transp < Data/mDeiJInterpiter26.H  plane=34 | Grey ${gpar6} > tmp2.H
	Cubeplot < tmp1.H esize=1 frame1=100 frame2=290 frame3=31 title='(a)'  ${cpar} wantaxes1=n  out=junk1.v >/dev/null
	Cubeplot < tmp2.H esize=1 frame1=100 frame2=290 frame3=31 title='(b)'  ${cpar}  out=junk2.v >/dev/null
	vppen < junk1.v vpstyle=n xshift=0 yshift=10.5 > 1.v
	vppen < junk2.v vpstyle=n xshift=0 yshift=0.5 > 2.v
	vppen 1.v 2.v erase=n scale=0.2 > $@
	python pycode/pyRemove.py 1.v 2.v  junk*.v	
	python ~/Setup/pyRemove.py tmp1.H tmp2.H 

gpar7 = eout=1 gainpanel=a pclip=95. 
winparzoomdown = n4=1 f4=14 | Window3d n2=240 f2=180 | Window3d n1=200 f1=250 | Bandpass flo=0.0005
cpar4 = point2=0.6 point2=0.6 screenratio=0.5 titlefat=2 titlesz=14 wheretitle=t wantcoordlabel=-1 label1='z(m)' label2='x(m)' label3='hx(m)' labelsz=5 >/dev/null

Fig/zoomdowndeimos.v:
	python ~/Setup/pyRemove.py tmp1.H tmp2.H
	Transp < Data/mDeiIInterpiter2.H  plane=34  | Window3d ${winparzoomdown}  | Grey ${gpar7} > tmp1.H
	Transp < Data/mDeiIInterpiter26.H  plane=34 | Window3d ${winparzoomdown} | Grey ${gpar7} > tmp2.H
	Agc < tmp1.H | Cubeplot esize=1 frame1=100 frame2=118 frame3=31 title='(a)'  ${cpar4} wantaxes1=n  out=junk1.v >/dev/null
	Agc < tmp2.H | Cubeplot esize=1 frame1=100 frame2=118 frame3=31 title='(b)'  ${cpar4}  out=junk2.v >/dev/null
	vppen < junk1.v vpstyle=n xshift=0 yshift=10.5 > 1.v
	vppen < junk2.v vpstyle=n xshift=0 yshift=0.5 > 2.v
	vppen 1.v 2.v erase=n scale=0.2 > $@
	python pycode/pyRemove.py 1.v 2.v  junk*.v	
	python ~/Setup/pyRemove.py tmp1.H tmp2.H 
	
Fig/zoomjointdeimos.v:
	python ~/Setup/pyRemove.py tmp1.H tmp2.H
	Transp < Data/mDeiJInterpiter2.H  plane=34  | Window3d ${winparzoomdown}  | Grey ${gpar7} > tmp1.H
	Transp < Data/mDeiJInterpiter26.H  plane=34 | Window3d ${winparzoomdown} | Grey ${gpar7} > tmp2.H
	Agc < tmp1.H | Cubeplot esize=1 frame1=100 frame2=118 frame3=31 title='(a)'  ${cpar4} wantaxes1=n  out=junk1.v >/dev/null
	Cubeplot < tmp2.H esize=1 frame1=100 frame2=118 frame3=31 title='(b)'  ${cpar4}  out=junk2.v >/dev/null
	vppen < junk1.v vpstyle=n xshift=0 yshift=10.5 > 1.v
	vppen < junk2.v vpstyle=n xshift=0 yshift=0.5 > 2.v
	vppen 1.v 2.v erase=n scale=0.2 > $@
	python pycode/pyRemove.py 1.v 2.v  junk*.v	
	python ~/Setup/pyRemove.py tmp1.H tmp2.H 



	
