# A script that does conjugate gradient calculations
#! /usr/bin/env python
#from SEP import *
import commands,re,string,sys,os
import datetime
import sys
import subprocess
sys.path.append('./pycode')
from pyBath import *
import pyInvmodRegJoint


projdir = sys.argv[1]
plet    = sys.argv[2]
iter  = int(sys.argv[3])
datax = int(sys.argv[4])
modax = int(sys.argv[5])
dirdm   = sys.argv[6]
dirggm   = sys.argv[7]
dirgg   = sys.argv[8]
dirrr   = sys.argv[9]
dirrrm   = sys.argv[10]


# initialization
ggdgg = 0.
ggdrr = 0.
resid = 0.
residD  =[0.,0.,0.,0.,0.,0.,0.];
residm  =[0.,0.,0.,0.,0.,0.,0.];
dmDdm   =[0.,0.,0.,0.,0.,0.,0.];
ggmdggm =[0.,0.,0.,0.,0.,0.,0.];
ggDdggD =[0.,0.,0.,0.,0.,0.,0.];
ggmdrrm =[0.,0.,0.,0.,0.,0.,0.];
ggDdrrD =[0.,0.,0.,0.,0.,0.,0.];
sbin='Bin'

# Calculagte residual in model space
# Calculate ddmDddm
os.system('rm -f '+projdir+'/temp.txt')
cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%sTotaliter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirdm,iter,projdir)
print cmd1
os.system(cmd1)

f2 = open(projdir+'/temp.txt', 'r')
str1 = f2.readline()
pyInvmodRegJoint.DPsum(float(str1),dmDdm)
# Calculate ggmdggm
os.system('rm -f '+projdir+'/temp.txt')
cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirggm,iter,projdir)
os.system(cmd1)

f2 = open(projdir+'/temp.txt', 'r')
str1 = f2.readline()
pyInvmodRegJoint.DPsum(float(str1), ggmdggm)
# calculate ggmdrrm
os.system('rm -f '+projdir+'/temp.txt')
cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%siter%s.H file2=%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirggm,iter,dirrrm,iter,projdir)
print cmd1
os.system(cmd1)
f2 = open(projdir+'/temp.txt', 'r')
str1 = f2.readline()
pyInvmodRegJoint.DPsum(float(str1), ggmdrrm)
# calculate rrmdrrm
os.system('rm -f '+projdir+'/temp.txt')
cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirrrm,iter,projdir)
os.system(cmd1)
f2 = open(projdir+'/temp.txt', 'r')
str1 = f2.readline()
pyInvmodRegJoint.DPsum(float(str1), residm)

# calculating residual in data space
for i in K[:]:
	shot = i
	# calculating ggdgg
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirgg+"up",shot,iter,projdir)
	os.system(cmd1)
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	pyInvmodRegJoint.DPsum(float(str1), ggDdggD)
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirgg+"dn",shot,iter,projdir)
	os.system(cmd1)
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	pyInvmodRegJoint.DPsum(float(str1), ggDdggD)
	# Calculating ggdrr
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%s%siter%s.H file2=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirgg+"up",shot,iter,dirrr+"up",shot,iter,projdir)
	print cmd1
	os.system(cmd1)
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	pyInvmodRegJoint.DPsum(float(str1), ggDdrrD)
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%s%siter%s.H file2=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirgg+"dn",shot,iter,dirrr+"dn",shot,iter,projdir)
	os.system(cmd1)
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	pyInvmodRegJoint.DPsum(float(str1), ggDdrrD)
	# calculating rrdrr
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirrr+"up",shot,iter,projdir)
	os.system(cmd1)
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	pyInvmodRegJoint.DPsum(float(str1), residD)
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirrr+"dn",shot,iter,projdir)
	os.system(cmd1)
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	pyInvmodRegJoint.DPsum(float(str1), residD)

ggdgg = ggDdggD[6] + ggmdggm[6]
ggdrr = ggDdrrD[6] + ggmdrrm[6]
resid = residD[6]  + residm[6]


# Perform cg step to get alpha
os.system("rm -f "+projdir+"/alpha.txt")
cmd1="%s/modcgstep.x Forget=1 ggdgg=%s ggdrr=%s outtag=%s/alpha.txt >/dev/null "%(sbin,ggdgg,ggdrr,projdir)
os.system(cmd1)
f = open(projdir+"/alpha.txt")
alpha = float(f.readline())
beta = 0.
f.close()

# Saves the residual in data space	

if (iter==1):
	os.system('rm -f '+projdir+'/ResidualData.txt')
	file = open(projdir+"/ResidualData.txt","w")
	cmd1 = "Iter ggDdggD ggDdrrD ssDdssD ssDdrrD ssDdggD residD \n"
	file.writelines(cmd1);
else:
	file = open(projdir+"/ResidualData.txt","a")
cmd1 = "1 %s %s 0. 0. 0. %s \n "%(ggDdggD[6], ggDdrrD[6],residD[6])
file.writelines(cmd1);
file.close()
# Saves the residual in model space
if (iter==1):
	os.system('rm -f '+projdir+'/ResidualModel.txt')
	file = open(projdir+"/ResidualModel.txt","w")
	cmd1 = "Iter ggmdggm ggmdrrm ssmdssm ssmdrrm ssmdggm residm \n"
	file.writelines(cmd1);
else:
	file = open(projdir+"/ResidualModel.txt","a")
cmd1 = "1 %s %s 0. 0. 0. %s \n "%(ggmdggm[6], ggmdrrm[6],residm[6])
file.writelines(cmd1);
file.close()
# Saves the total residual
if (iter==1):
	os.system('rm -f '+projdir+'/ResidualTotal.txt')
	file = open(projdir+"/ResidualTotal.txt","w")
	cmd1 = "Iter ggdgg ggdrr ssdss ssdrr ssdgg resid \n"
	file.writelines(cmd1);
else:
	file = open(projdir+"/ResidualTotal.txt","a")

cmd1 = "1 %s %s 0. 0. 0. %s \n "%(ggdgg, ggdrr,resid)
file.writelines(cmd1);
file.close()
# Saves the percent residual
if (iter==1):
	os.system('rm -f '+projdir+'/ResidualPercent.txt')
	file = open(projdir+"/ResidualPercent.txt","w")
	cmd1 = "Iter ggdgg ggdrr ssdss ssdrr ssdgg resid \n"
	file.writelines(cmd1);
else:
	file = open(projdir+"/ResidualPercent.txt","a")

cmd1 = "%s %s %s 0.00 0.00 0.00 %s \n "%(iter,str(round(ggmdggm[6]/ggdgg*100,2)), str(round(ggmdrrm[6]/ggdrr*100,2)), str(round(residm[6]/resid*100,2)))
file.writelines(cmd1);
file.close()


# Save the step size
if (iter==1):
	os.system('rm -f '+projdir+'/Reportsave.txt')
	file = open(projdir+'/Reportsave.txt',"w")
	file.writelines("iter alpha beta dmDdm Data_resid Model_resid Objective \n")
else:
	file = open(projdir+'/Reportsave.txt',"a")

cmd1 = " %s %s 0. %s %s %s %s \n "%(iter, alpha, str(dmDdm[6]), str(residD[6]), str(residm[6]), str(resid))
print cmd1
file.writelines(cmd1);
file.close()

