#! /usr/bin/env python
#from SEP import *
import commands 
import re,string
import sys, os
import os.path 
from pyBath import *


shot = int(sys.argv[1])
jobname = sys.argv[2]
iter = int(sys.argv[3])
outdir = sys.argv[4]
projdir = sys.argv[5]
plet    = sys.argv[6]
velfile = sys.argv[7]
parfile = sys.argv[8]
smooth  = sys.argv[9]
lpfil   = sys.argv[10]
VDer    = sys.argv[11]
gauss   = sys.argv[12]
DW      = sys.argv[13]
nhx     = sys.argv[14]
souwfld = sys.argv[15]
MWfile = sys.argv[16]
DWfile  = sys.argv[17]
UD = int(sys.argv[18])  # 1=up, 2=dn

nodes = 1   # number of nodes for each job
ppn=8     # number of processor per node
walltime='24:00:00'  # max time to wait for the job to finish
pmem = '2gb'  # max memory to allocate for the job


Gx = L[int(shot)][1]  # get shot x

os.system("rm -f %s/out2.par; sed '/#/d' Par/%s | sed '/^$/d' | tr '\n' ' ' > %s/out2.par"%(projdir,parfile,projdir))
f1 = open("%s/out2.par"%(projdir))
param = f1.readline()
f1.close()
#print 'parfile', parfile
#print '%s/out2.par'%(projdir)
#print 'param', param
dirrr = projdir+"/rr/rrDei"+plet
dirdm = projdir+"/dm/dmDei"+plet


# Constructing logfile and cmdfile
if (os.path.isdir('%s/pbs'%(outdir)) != 1):
	os.system('mkdir %s/pbs'%(outdir))
if (os.path.isdir('%s/logfile'%(outdir)) != 1):
	os.system('mkdir %s/logfile'%(outdir))
cmdfile = "%s/pbs/PBS%s%s.txt"%(outdir,plet,shot)
logfile = "%s/logfile/Adj%s.txt"%(outdir,shot)
os.system("rm -f %s %s"%(cmdfile,logfile))

# Get Source wfld file index and data masking param
bfile = swfile[shot][2*int(UD)-1]
efile = swfile[shot][2*int(UD)]

dt=ForwardTime[0][0]
nt=ForwardTime[0][2*int(UD)-1]
ot=ForwardTime[0][2*int(UD)]

cmd0 ='python pycode/pyRemove.py  %s%siter%s.H '%(dirdm,shot,iter)

cmd1 = "Bin/Mig_Main3D_Off.x velin=%s %s nt=%s dt=%s ot=%s vmax=4500 nodes=%s smooth=%s lpfil=%s VDer=%s gauss=%s DW=%s DWfile=%s%s.H  wfldsou=%s%s.H bfile=%s efile=%s recfile=%s%siter%s.H MWfile=%s%s.H wfmout=0 outtag=%s%siter%stmp.H >& %s"%(velfile,param,nt,dt,ot,ppn, smooth, lpfil, VDer, gauss, DW, DWfile, shot, souwfld, shot, bfile, efile, dirrr, shot, iter, MWfile, shot, dirdm, shot, iter,logfile)
cmd2 = 'Bin/offsetmask.x < %s%siter%stmp.H vel=6. zmute=100. outfile1=%s%siter%stmp2.H >/dev/null'%(dirdm,shot,iter,dirdm,shot,iter) 
cmd3 = 'Bin/Testkzkh.x < %s%siter%stmp2.H outtag=%s%siter%s.H elseouttag=%s%siter%safter2.H zhout=1 kzkhout=0 Gx=%s shotnum=%s UD=%s >/dev/null '%(dirdm,shot,iter,dirdm,shot,iter,dirdm,shot,iter,Gx,shot,UD)	
cmd4 ='python pycode/pyRemove.py %s%siter%stmp.H %s%siter%stmp2.H %s%siter%safter2.H'%(dirdm,shot,iter,dirdm,shot,iter,dirdm,shot,iter)

os.system("echo '%s' >> %s"%(cmd0,cmdfile))
os.system("echo '%s' >> %s"%(cmd1,cmdfile))
os.system("echo '%s' >> %s"%(cmd2,cmdfile))
os.system("echo '%s' >> %s"%(cmd3,cmdfile))
os.system("echo '%s' >> %s"%(cmd4,cmdfile))

newnode='1'
cmd1 = "pycode/pyWritePBSsep.py %s %s %s %s %s %s"%(newnode,ppn,walltime,pmem,jobname,cmdfile)

print cmd1	
os.system( cmd1)
os.system('sleep 2')

