#! /usr/bin/env python
#from SEP import *
import commands 
import re,string
import sys, os
import os.path 
from pyBath import *


shot = int(sys.argv[1])
jobname = sys.argv[2]
iter = int(sys.argv[3])
outdir = sys.argv[4]
projdir = sys.argv[5]
plet    = sys.argv[6]
velfile = sys.argv[7]
parfile = sys.argv[8]
smooth  = sys.argv[9]
lpfil   = sys.argv[10]
VDer    = sys.argv[11]
gauss   = sys.argv[12]
DW      = sys.argv[13]
nhx     = sys.argv[14]
souwfld = sys.argv[15]
MWfile = sys.argv[16]
DWfile  = sys.argv[17]
UD = int(sys.argv[18])

nodes = 1   # number of nodes for each job
ppn=16     # number of processor per node
walltime='24:00:00'  # max time to wait for the job to finish
pmem = '2gb'  # max memory to allocate for the job

os.system("rm -f %s/out1.par; sed '/#/d' Par/%s | sed '/^$/d' | tr '\n' ' ' > %s/out1.par"%(projdir,parfile,projdir))
f1 = open("%s/out1.par"%(projdir))
param = f1.readline()
f1.close()
print '*************'
#print 'parfile', parfile
#print 'param', param
dirgg = projdir+"/gg/ggDei"+plet
dirdm = projdir+"/dm/dmDei"+plet

# Constructing logfile and cmdfile
if (os.path.isdir('%s/pbs'%(outdir)) != 1):
        os.system('mkdir %s/pbs'%(outdir))
if (os.path.isdir('%s/logfile'%(outdir)) != 1):
        os.system('mkdir %s/logfile'%(outdir))
cmdfile = "%s/pbs/PBS%s%s.txt"%(outdir,plet,shot)
logfile = "%s/logfile/For%s.txt"%(outdir,shot)
os.system("rm -f %s %s"%(cmdfile,logfile))

# Get Source wfld file index and data masking param
bfile = swfile[shot][2*int(UD)-1]
efile = swfile[shot][2*int(UD)]


dt=ForwardTime[0][0]
nt=ForwardTime[0][2*int(UD)-1]
ot=ForwardTime[0][2*int(UD)]

drt=ReceiverTime[0][0]
nrt=ReceiverTime[0][2*int(UD)-1]
ort=ReceiverTime[0][2*int(UD)]


cmd0 ='python pycode/pyRemove.py %s%siter%s.H '%(dirgg,shot,iter)
#cmd1 = "Bin/Forward3D.x velin='%s' %s nt=%s ot=%s dt=%s nrt=%s ort=%s drt=%s vmax=4500. nodes=%s smooth=%s lpfil=%s VDer=%s gauss=%s DW=%s DWfile=%s%s.H wfldsou=%s%s.H bfile=%s efile=%s reflfile=%sTotaliter%s.H MWfile=%s%s.H outtag=%s/tmp%s%s.H >& %s "%(velfile, param, nt, ot, dt, nrt,ort,drt, ppn, smooth, lpfil, VDer, gauss, DW, DWfile, shot, souwfld, shot, bfile, efile, dirdm,iter, MWfile, shot,  outdir, plet, shot,logfile)
cmd1 = "Bin/Forward3D_Off.x velin='%s' %s nt=%s ot=%s dt=%s nrt=%s ort=%s drt=%s vmax=4500. nodes=%s smooth=%s lpfil=%s VDer=%s gauss=%s DW=%s DWfile=%s%s.H wfldsou=%s%s.H bfile=%s efile=%s reflfile=%sTotaliter%s.H  MWfile=%s%s.H outtag=%s/tmp%s%s.H >& %s "%(velfile, param, nt, ot, dt, nrt,ort,drt, ppn, smooth, lpfil, VDer, gauss, DW, DWfile, shot, souwfld, shot, bfile, efile, dirdm,iter, MWfile, shot,  outdir, plet, shot,logfile)
print cmd1
cmd2 = ' < %s/tmp%s%s.H ${SEPBIN}/Bandpass flo=3. fhi=25. > %s%siter%s.H'%(outdir,plet,shot,dirgg,shot,iter)
cmd3 = 'python pycode/pyRemove.py  %s/tmp%s%s.H %s/tmpp%s%s.H '%(outdir,plet,shot,outdir,plet,shot)
os.system("echo '%s' >> %s"%(cmd0,cmdfile))
os.system("echo '%s' >> %s"%(cmd1,cmdfile))
os.system("echo '%s' >> %s"%(cmd2,cmdfile))
os.system("echo '%s' >> %s"%(cmd3,cmdfile))



newnode='1'
cmd1 = "pycode/pyWritePBSsep.py %s %s %s %s %s %s"%(1,ppn,walltime,pmem,jobname,cmdfile)
print cmd1	
os.system( cmd1)
os.system('sleep 2')

	

