#! /usr/bin/env python
#from SEP import *
import commands as cmd
import re,string
import sys, os
import os.path as path
import fileinput
from pyBath import *


nnode = 100  # max number of jobs to run simultaneously
jmax  = 2000 # max amount of 20 sec to wait before qutting
sbin = "./Bin"
#-------------------------------------------------------------

def waitforjob(jobnameMain,logdir,TotalMin):

	j=0
	while (j <= TotalMin*3):
		os.system("rm -f "+logdir+"/check."+jobnameMain)
		cmd2= "qstat  | grep \"mandyman\" | grep \"C sep\" -v | grep \"C default\" -v |grep \"%s\" -c  >> %s/check.%s"%(jobnameMain,logdir,jobnameMain)
		#print cmd2
		os.system(cmd2)
		f = open(logdir+'/check.'+jobnameMain)
		PEN = int(f.readline())
		if ((PEN) >= 1):
			if (j%3 == 1):
				stg2 = "%s; pending=%s, Time %s mins"%(jobnameMain, PEN,j/3)
				print stg2
			os.system('sleep 20')
			j=j+1
		else:
			break;

	if (j >= TotalMin*3):    # waited too long, quit job
		print 'waited too long, quit job'
		sys.exit('exit now to quit job')

	


def Ratio(maindir,projdir,plet,K,Rname,modax,datax,iter):

	dirdm = projdir+"/dm/dmDei"+plet
	dirggm = projdir+'/ggm/ggmDei'+plet	
	dirgg = projdir+'/gg/ggDei'+plet	
	ggmdggm = 0.
	ggDdggD = 0.

        cmd1 = "%s/%s adj=0 naxis=%s eps=1.0 infile=%sTotaliter%s.H outfile=%sTemp.H >/dev/null"%(sbin,Rname, modax, dirdm,iter,dirggm)
	print cmd1
        os.system(cmd1)

	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%sTemp.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirggm,projdir)
	print cmd1
	os.system(cmd1)	
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	ggmdggm = ggmdggm + float(str1)
	os.system('Rm %sTemp.H'%(dirggm))


        # calculating residual in data space
	for i in K[:]:
		shot = i
		# calculating ggdgg 
		os.system('rm -f '+projdir+'/temp.txt')
		cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirgg,shot,iter,projdir)
		print cmd1
		os.system(cmd1)	
		f2 = open(projdir+'/temp.txt', 'r')
		str1 = f2.readline()
		ggDdggD = ggDdggD + float(str1)

	# Calculate the ratio
	if (ggmdggm > 0.):
		ratio = (ggDdggD/ggmdggm)**(0.5)
	else:
		ratio = 1.

	print 'Ratio calculation for iter', iter
	print 'ggmDggm ggDdggD', ggmdggm, ggDdggD
	print 'ratio', ratio


	return ratio

############################################################################
def checkjob(jobname,projdir,logdir,outfile,iter,K):


	print 'checkjob:', jobname, logdir,outfile

	j=0
	while (j <= jmax):
		os.system("rm -f "+logdir+"/check."+jobname)
		cmd2= "qstat  | grep \"mandyman\" | grep \"C sep\" -v | grep \"C default\" -v|  grep \"%s\" -c  >> %s/check.%s"%(jobname,logdir,jobname)
		os.system(cmd2)
		f = open(logdir+'/check.'+jobname)
		PEN = int(f.readline())
		if (PEN >= 1):
			stg2 = "pending/running %s jobs: %s "%(jobname, PEN)
			print stg2
			if (j%3 == 1):
				 print 'checkjob for', jobname,'waited for', j/3, 'mins' 
			os.system('sleep 20')
			j=j+1
		else:
			break;

        # -----------------------------------------------------------
        #---- Check rather all the output file exist ----------------
        # -----------------------------------------------------------
	print 'checkjob: check rather all output file exist'
	status = []
	for i in range(1,len(K)+1):
		shot = K[i-1]
		status.append(i)
		searchname = "%s%siter%s.H"%(outfile,shot,iter)
		print 'searching for filename:', searchname
		lenn = len(searchname)
		os.system("${SEPBIN}/In %s | grep \"in=\" >> %s/CKout%siter%s.txt"%(searchname, logdir, shot,iter))
		file = open("%s/CKout%siter%s.txt"%(logdir, shot,iter))
		line = file.readline()
		pos=line.find("in=")
		binaryfile = line[pos+3:len(line)-1]
		#print "binary", binaryfile
		os.system('rm -r %s/CKout%siter%s.txt'%(logdir, shot,iter))
		if (not os.path.exists(binaryfile)):
			stg2 = 'Adjoint3D: shot %s iter %s not done'%(shot,iter)
			print stg2
		else:
			print 'file exist:', searchname
			status[i-1] = 0.;

	if (sum(status) == 0. ):
		print 'Jobname',jobname,'for iter # ',iter,' is finished sucessfully'
	else:
		print "Not all job is finish for',jobname, 'iter#", iter
		print "print job status"
		print K
		print status
		print sys.exit("Exit now")

	return

#############################################################################

def Adjoint(maindir, projdir, velfile, parfile, plet, UD, smooth, lpfil, VDer, gauss, DW, souwfld,MWfile, DWfile, Rname, eps,ratio, modax, nhx, iter):

	jobname = "Adj%siter%s"%(plet,iter)
	jobscpt = maindir + '/pyinv5/pyAdjointOneDir.py'
	outdir = projdir+'/dm'
        dirrrm = projdir + '/rrm/rrmDei'+plet
        dmm    = projdir + '/dm/dmMDei'+plet
        dm    = projdir + '/dm/dmDei'+plet

	os.system('rm %s/JN/JNAdj%siter%s.txt'%(projdir,plet,iter))
	# -----------------------------------------------------------
        #---- First calculate eps A' Rm  ----------------------------
        # -----------------------------------------------------------
        # Set ramping of the eps from zero to maxeps over 5 iterations
        ramp=[0.2,0.4,0.6,0.8]
        
        if iter <= len(ramp):
        	EPS = ramp[iter-1]*eps*ratio
        	print 'EPS, ramp[iter-1], eps, ratio', EPS, ramp[iter-1], eps, ratio
        else:
        	EPS = eps*ratio
        
        cmd1 = "%s/%s adj=1 naxis=%s eps=%s infile=%siter%s.H outfile=%siter%s.H >/dev/null "%(sbin,Rname, modax, EPS, dirrrm,iter,dmm,iter)
        os.system(cmd1)


	# -----------------------------------------------------------
        #---- Run the jobs  -----------------------------------------
        # -----------------------------------------------------------
        for i in range(1,len(K)+1):
        	shot = K[i-1]
		os.system("sleep 2")
		jobnameInd = jobname+'_%s'%(shot)	
		print 'Adjoint: submitting job #', jobnameInd
		stg1 = '%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s&'%(jobscpt,shot,jobnameInd, iter, outdir,projdir,plet, velfile, parfile, smooth, lpfil, VDer, gauss, DW, nhx, souwfld,MWfile, DWfile, UD)
		print stg1
		os.system(stg1)

	
	# Something that check jobs
	checkjob(jobname,projdir,outdir,dm,iter,K)		
	 			
	return


#############################################################################

def Forward(maindir, projdir, velfile, parfile, plet, UD, smooth, lpfil, VDer, gauss, DW, souwfld, MWfile, DWfile, Rname, eps,ratio, modax, nhx, iter):

	jobname = "For%siter%s"%(plet,iter)
	jobscpt = maindir + '/pyinv5/pyForwardOneDir.py'
	outdir = projdir + '/gg'
	dirdm = projdir+"/dm/dmDei"+plet
	dirggm = projdir+'/ggm/ggmDei'+plet	
	dirgg = projdir+'/gg/ggDei'+plet	

	cmdfile2 = '%s/pbs/ForwardPre%s.txt'%(outdir,plet)
	jobname2 = 'ForwardPre%siter%s'%(plet,iter)
	logdir = '%s/pbs/logfile'%(outdir)
	os.system('rm %s'%(cmdfile2))

	os.system('rm %s/JN/JNFor%siter%s.txt'%(projdir,plet,iter))
	# -----------------------------------------------------------
        #---- First, calculate ggm - eps A dm  ----------------------
        # -----------------------------------------------------------
        # Set ramping of the eps from zero to maxeps over 5 iterations
        ramp=[0.2,0.4,0.6,0.8,1.0]
        
        if iter <= len(ramp):
        	EPS = ramp[iter-1]*eps*ratio
        else:
        	EPS = eps*ratio
                        
        os.system('rm -f '+projdir+'/Epsilon.txt')
        if iter == 2:
		file = open(projdir+"/ResidualData.txt","w")
		cmd1 = "Iter ramp eps ratio EPS \n"
		file.writelines(cmd1);
	else:
		file = open(projdir+"/ResidualData.txt","a")
		
	cmd2 = "%s %s %s %s %s \n"%(iter, ramp[min(iter-1,len(ramp)-1)],eps,ratio,EPS)
	file.writelines(cmd2);
	file.close()
        
        cmd1 = "%s/%s adj=0 naxis=%s eps=%s infile=%sTotaliter%s.H outfile=%siter%s.H >/dev/null"%(sbin,Rname, modax, EPS, dirdm,iter,dirggm,iter)
	os.system("echo '%s' >> %s"%(cmd1,cmdfile2))
	# Model from ADCIG to ODCIG
#	cmd2 ='python pycode/pyRemove.py  fmp1%s.H fmp1off%s.H '%(plet,plet)
#	cmd3 = "Transp < %sTotaliter%s.H reshape=1,3,5 plane=23 > fmp1%s.H"%(dirdm,iter,plet)
#	cmd4 = "OFF2ANG < fmp1%s.H inverse=1 > fmp1off%s.H "%(plet,plet)
#	cmd5 = "Transp < fmp1off%s.H reshape=1,3,5 plane=23 > fmp2off%s.H"%(plet,plet)
#	cmd6 ='python pycode/pyRemove.py  fmp1%s.H fmp1off%s.H '%(plet,plet)
#	os.system("echo '%s' >> %s"%(cmd1,cmdfile2))
#	os.system("echo '%s' >> %s"%(cmd2,cmdfile2))
#	os.system("echo '%s' >> %s"%(cmd3,cmdfile2))
#	os.system("echo '%s' >> %s"%(cmd4,cmdfile2))
#	os.system("echo '%s' >> %s"%(cmd5,cmdfile2))
#	os.system("echo '%s' >> %s"%(cmd6,cmdfile2))

	# Submit and check above jobs
        cmd1 = "pycode/pyWritePBSsep.py %s %s %s %s %s %s"%(1,8,'24:00:00','2gb',jobname2,cmdfile2)
	os.system( cmd1)
	waitforjob(jobname2,logdir,1800)

	# -----------------------------------------------------------
        #---- Run the jobs  -----------------------------------------
        # -----------------------------------------------------------
	for i in K:
		shot=K[i-1]
		os.system("sleep 2")	
		jobnameInd=jobname+"_%s"%(shot)	
		print 'Forward: submitting shot #', jobnameInd
		stg1 = '%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s &'%(jobscpt,shot,jobnameInd, iter, outdir,projdir,plet, velfile, parfile, smooth, lpfil, VDer, gauss, DW, nhx, souwfld, MWfile, DWfile, UD)
#		print stg1
		os.system(stg1)


	# Something that check jobs
	checkjob(jobname,projdir,outdir,dirgg,iter,K)		

#	cmd7 = 'python pycode/pyRemove.py  fmp2off%s.H '%(plet)
#	os.system(cmd7)
	 			

	return


# ####################################


def Add(maindir,projdir, d1,  iter, naxis, plet,dmm,dirdm):
	# naxis: number of axes in files to be summed
        d1BK=d1+"BK"
	outdir = projdir+'/dm'

	scpt = 'pyinv5/pyAddrtm.py'
	stg1 = '%s %s %s %s %s %s %s %s'%(scpt,outdir,d1,iter,naxis,plet,dmm,dirdm)
	print stg1
	os.system(stg1)

	#wait for job to finish (have the exact same jobname as specified in pyAddrtm.py'
	jobname='Add%s%s'%(plet,iter)
	waitforjob(jobname,outdir,1800)
	
		# Now check if final output file exist
	# If so, erase all intermediate outputs (except for a selected few)
	searchname = "%sSUMiter%s.H"%(d1,iter)
	print 'searching for filename:', searchname
	lenn = len(searchname)
	os.system("${SEPBIN}/In %s | grep \"in=\" >> %s/CKoutTotaliter%s.txt"%(searchname, outdir,iter))
	file = open("%s/CKoutTotaliter%s.txt"%(outdir,iter))
	line = file.readline()
	pos=line.find("in=")
	binaryfile = line[pos+3:len(line)-1]
	#print "binary", binaryfile
	os.system('rm -r %s/CKoutTotaliter%s.txt'%(outdir,iter))
	if (not os.path.exists(binaryfile)):
		stg2 = 'Add rtm : plet %s iter %s not done'%(plet,iter)
		sys.exit('Add rtm files failed, exit')

#	# Start erasing intermediate files
#	print 'len EK'
#	for i in EK[:]:
#        	cmd1 = 'python pycode/pyRemove.py %s%siter%s.H'%(d1,i,iter)
#		os.system(cmd1)

	
	return
           	  	
# ####################################	
# Conjugate Gradient (CG) model update

def CGmodelupdate(alpha,projdir,plet,iter,datax,modax,dirrr,dirgg,dirss,dirrrm,dirggm,dirssm,dirdm,dirm,dirs):

	## Update the  data residual files
	logdir = '%s/pbs/logfile'%(projdir)
	cmdfile = '%s/pbs/updateiter%s.txt'%(projdir,iter)
	jobnameMain = 'UpD%s_%s'%(plet,iter)
        os.system('rm -f %s'%(cmdfile))
	for i in K[:]:
                print 'residual update, iter',iter, 'shot', i
                #  calculate your ss file ss=alpha*gg	
                C1 = "%s/updateAB.x alpha=%s cg=1 naxis=%s file1=%s%siter%s.H outfile=%s%siter%s.H >/dev/null"%(sbin,alpha,datax,dirgg,i,iter,dirss,i,iter+1)
		os.system("echo '%s' >> %s"%(C1,cmdfile))			             
		#  update your current residual here  rr = rr+ss
		C1 = "%s/updateAB.x alpha=1.0 beta=1.0 naxis=%s file1=%s%siter%s.H file2=%s%siter%s.H outfile=%s%siter%s.H >/dev/null"%(sbin,datax,dirrr,i,iter,dirss,i,iter+1,dirrr,i,iter+1)
		os.system("echo '%s' >> %s"%(C1,cmdfile))			             

		
	## Update the  model residual files
	# calculate ssm = alpha*ggm 
	C1 = "%s/updateAB.x alpha=%s cg=1 naxis=%s file1=%siter%s.H outfile=%siter%s.H >/dev/null"%(sbin,alpha,modax,dirggm,iter,dirssm,iter+1)
	os.system("echo '%s' >> %s"%(C1,cmdfile))			             
	# Calculate your new rrm = rrm + ssm
	C1 = "%s/updateAB.x alpha=1.0 beta=1.0 naxis=%s file1=%siter%s.H file2=%siter%s.H outfile=%siter%s.H >/dev/null"%(sbin,modax,dirrrm,iter,dirssm,iter+1,dirrrm,iter+1)	
	os.system("echo '%s' >> %s"%(C1,cmdfile))			             

	
	## Update the model files
	# Calculate your new s=alpha*dm
	print 'update model, iter',iter
	C1 = "%s/updateAB.x alpha=%s cg=1 naxis=%s file1=%sTotaliter%s.H outfile=%sTotaliter%s.H >/dev/null"%(sbin,alpha,modax,dirdm,iter,dirs,iter+1)
	os.system("echo '%s' >> %s"%(C1,cmdfile))	             
	# Calculate your new m = m+s
	C1 = "%s/updateAB.x alpha=1. beta=1. naxis=%s file1=%sTotaliter%s.H file2=%sTotaliter%s.H outfile=%sTotaliter%s.H >/dev/null"%(sbin,modax,dirm,iter,dirs,iter+1,dirm,iter+1)	
	os.system("echo '%s' >> %s"%(C1,cmdfile))

        # Submit job and wait until it is done
        cmd1 = "pycode/pyWritePBSsep.py %s %s %s %s %s%s %s"%(1,8,'24:00:00','2gb',jobnameMain,i,cmdfile)
        os.system( cmd1)
        waitforjob(jobnameMain,logdir,1800)

	return

# ####################################	
# Conjugate Direction (CD) model update

def CDmodelupdate(alpha,beta,projdir,plet,iter,datax,modax,dirrr,dirgg,dirss,dirrrm,dirggm,dirssm,dirdm,dirm,dirs):

	## Update the residual files
	print 'update data residual, iter', iter
	cmdfile = '%s/pbs/updateiter%s.txt'%(projdir,iter)
	logdir = '%s/pbs/logfile'%(projdir)
	jobnameMain = 'UpD%s_%s'%(plet,iter)
        os.system('rm -f %s'%(cmdfile))
	for i in K[:]:
        	print 'residual update, iter', iter, 'shot', i
                #  calculate your ss file ss=alpha*rr+beta*ss	
        	C1 = "%s/updateAB.x alpha=%s beta=%s naxis=%s file1=%s%siter%s.H file2=%s%siter%s.H outfile=%s%siter%s.H >/dev/null"%(sbin,alpha,beta,datax,dirgg,i,iter,dirss,i,iter,dirss,i,iter+1)
		os.system("echo '%s' >> %s"%(C1,cmdfile))
			             
		#  update your current residual here  rr=rr+ss
		C1 = "%s/updateAB.x alpha=1.0 beta=1.0 naxis=%s file1=%s%siter%s.H file2=%s%siter%s.H outfile=%s%siter%s.H >/dev/null"%(sbin,datax,dirrr,i,iter,dirss,i,iter+1,dirrr,i,iter+1)	
		os.system("echo '%s' >> %s"%(C1,cmdfile))

	## Update the  model residual files
	print 'update model residual, iter', iter
	# calculate ssm = alpha*ggm 
	C1 = "%s/updateAB.x alpha=%s cg=1 naxis=%s file1=%siter%s.H outfile=%siter%s.H >/dev/null"%(sbin,alpha,modax,dirggm,iter,dirssm,iter+1)
	os.system("echo '%s' >> %s"%(C1,cmdfile))

	## Calculate your new rrm = rrm + ssm
	C1 = "%s/updateAB.x alpha=1.0 beta=1.0 naxis=%s file1=%siter%s.H file2=%siter%s.H outfile=%siter%s.H >/dev/null"%(sbin,modax,dirrrm,iter,dirssm,iter+1,dirrrm,iter+1)	
	os.system("echo '%s' >> %s"%(C1,cmdfile))

	## Update the model files
	# Calculate your new dm s=alpha*dm+beta*s
	print 'model update, iter', iter
	C1 = "%s/updateAB.x alpha=%s beta=%s naxis=%s file1=%sTotaliter%s.H file2=%sTotaliter%s.H outfile=%sTotaliter%s.H >/dev/null"%(sbin,alpha,beta,modax,dirdm,iter,dirs,iter,dirs,iter+1)	
	os.system("echo '%s' >> %s"%(C1,cmdfile))

	## Calculate your new m
	C1 = "%s/updateAB.x alpha=1.0 beta=1.0 naxis=%s file1=%sTotaliter%s.H file2=%sTotaliter%s.H outfile=%sTotaliter%s.H >/dev/null"%(sbin,modax,dirm,iter,dirs,iter+1,dirm,iter+1)	
	os.system("echo '%s' >> %s"%(C1,cmdfile))

	# Submit job and wait until it is done
	cmd1 = "pycode/pyWritePBSsep.py %s %s %s %s %s%s %s"%(1,8,'24:00:00','2gb',jobnameMain,i,cmdfile)
	os.system( cmd1)
	waitforjob(jobnameMain,logdir,1800)    

	return

# ####################################	
# add the DP by accumulated sum
def DPsum( number, varname):
	# 0=tmpP, 1=errP, 2=totP, 3=tmpM, 4=errM, 5=totM, 6=tot
#	print 'number', number
#	print 'varname', varname

	if ( number > 0.00000):
		varname[0] = varname[2] + number + varname[1]
		varname[1] = (varname[2]-varname[0])+number
		varname[2] = varname[0] 
	else:
		varname[3] = varname[5] + number + varname[4]
		varname[4] = (varname[5]-varname[3])+number
		varname[5] = varname[3] 

	varname[6] = varname[5] + varname[2]

# ####################################	
# Calculate the alpha only using double precision

def DPcalCG(projdir, plet,iter,datax, modax, dirdm, dirggm, dirgg, dirrr, dirrrm):

	cmdfile ='%s/pbs/DPcalCGiter%s.txt'%(projdir,iter)
	logfile = '%s/pbs/logfile'%(projdir)
	jobname = 'DP%s_%s'%(plet,iter)

	os.system('rm -f %s'%(cmdfile))
	cmd1 = 'python pyinv5/pyDPcalCG.py %s %s %s %s %s %s %s %s %s %s'%(projdir,plet,iter,datax,modax,dirdm,dirggm,dirgg,dirrr,dirrrm)
	print cmd1
	os.system("echo '%s' >> %s"%(cmd1,cmdfile))

	# Submit job and wait until it is done
	cmd1 = "pycode/pyWritePBSsep.py %s %s %s %s %s %s"%(1,8,'24:00:00','2gb',jobname,cmdfile)
	os.system( cmd1)
	waitforjob(jobname,logfile,1800)

	# initialize alpha and beta
	alpha=0.
	beta=0.

	# read the alpha values
        f = open(projdir+"/alpha.txt")
        alpha = float(f.readline())
        beta = 0.
        f.close()
	os.system('rm -f %s/alpha.txt'%(projdir))

	return alpha, beta

# ####################################	
# Calculate the alpha and beta using double precision

def DPcalCD(projdir, plet,iter,datax,modax, dirdm, dirggm, dirgg, dirrr, dirrrm, dirss, dirssm):

	cmdfile ='%s/pbs/DPcalCDiter%s.txt'%(projdir,iter)
	logdir = '%s/pbs/logfile'%(projdir)
	jobname = 'DP%s_%s'%(plet,iter)

	os.system('rm -f %s'%(cmdfile))
	cmd1 = 'python pyinv5/pyDPcalCD.py %s %s %s %s %s %s %s %s %s %s %s %s'%(projdir,plet,iter,datax,modax,dirdm,dirggm,dirgg,dirrr,dirrrm,dirss,dirssm)
	os.system("echo '%s' >> %s"%(cmd1,cmdfile))

	# Submit job and wait until it is done
	cmd1 = "pycode/pyWritePBSsep.py %s %s %s %s %s %s"%(1,8,'24:00:00','2gb',jobname,cmdfile)
	os.system( cmd1)
	waitforjob(jobname,logdir,1800)

	# initialize alpha and beta
	alpha=0.
	beta=0.

        # Read the alpha and beta values
	f = open(projdir+"/alpha.txt")
	alpha = float(f.readline())
	beta  = float(f.readline())
	f.close()	
	os.system("rm -f "+projdir+"/alpha.txt")

	return alpha, beta


# ####################################
def ResidCal(projdir, plet, K,iter,datax, dirrr):
	resid = 0.
	for i in K[:]:
		shot = i
		# calculating rrdrr
		os.system('rm -f '+projdir+'/temp.txt')
		cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirrr,shot,iter,projdir)
		print cmd1
		os.system(cmd1)	
		f2 = open(projdir+'/temp.txt', 'r')
		str1 = f2.readline()
		resid = resid + float(str1)
		
	return resid
# ###################################
# make a copy of current residual (rr)
# compare the current residual with from iter 1
# Remove the value that was amost statics
def EraseStatic(iter,refiter,datax,dirrr):
	# make a copy of current residual
	for i in [5]:
#	for i in K[:]:
		C1 = "%s/updateAB.x alpha=1.0 cg=1 naxis=%s file1=%s%siter%s.H outfile=%s%siter%sOld.H >/dev/null"%(sbin,datax,dirrr,i,iter,dirrr,i,iter)
		print C1	
		#os.system(C1)
	# run samevalue
		C2 = "%s/SameValue.x naxis=%s eps=0.02 infile1=%s%siter%sOld.H infile2=%s%siter%s.H outfile=tmpSame%siter%sV1.H >/dev/null"%(sbin,datax,dirrr,i,iter,dirrr,i,refiter,i,iter)
		C3 = "%s/SameValue.x naxis=%s eps=0.02 infile1=tmpSame%siter%sV1.H infile2=%s%siter%s.H outfile=tmpSame%siter%sV2.H >/dev/null"%(sbin,datax,i,iter,dirrr,i,refiter+1,i,iter)
		C4 = "%s/SameValue.x naxis=%s eps=0.02 infile1=tmpSame%siter%sV2.H infile2=%s%siter%s.H outfile=tmpSame%siter%sV3.H >/dev/null"%(sbin,datax,i,iter,dirrr,i,refiter+2,i,iter)
		C5 = "%s/SameValue.x naxis=%s eps=0.02 infile1=tmpSame%siter%sV3.H infile2=%s%siter%s.H outfile=tmpSame%siter%sV4.H >/dev/null"%(sbin,datax,i,iter,dirrr,i,refiter+3,i,iter)
		C6 = "%s/SameValue.x naxis=%s eps=0.02 sub=1 infile1=%s%siter%sOld.H infile2=tmpSame%siter%sV4.H outfile=%s%siter%s.H >/dev/null"%(sbin,datax,dirrr,i,iter,i,iter,dirrr,i,iter)
		print C2
		print C3
		print C4
		print C5
		print C6
		os.system(C2)
		os.system(C3)
		os.system(C4)
		os.system(C5)
		os.system(C6)
		C7 = "python pycode/pyRemove.py tmpSame%siter%sV1.H tmpSame%siter%sV2.H tmpSame%siter%sV3.H tmpSame%siter%sV4.H"%(i,iter,i,iter,i,iter,i,iter)
		print C7
		#os.system(C7)
	return
# ###################################
# Remove top n percents

def EraseTop(projdir,plet,iter,datax,dirrr):
	jobname = 'ET%s_'%(plet)
	logdir = '%s/pbs/logfile'%(projdir)
	for i in K[:]:
		cmdfile = '%s/pbs/EraseTop%s.txt'%(projdir,plet)
		os.system('rm -f %s'%(cmdfile))
		C1 = "%s/updateAB.x alpha=1.0 cg=1 naxis=%s file1=%s%siter%s.H outfile=%s%siter%sOld.H >/dev/null"%(sbin,datax,dirrr,i,iter,dirrr,i,iter)
		C2 = "%s/RemoveTop.x naxis=%s eps=0.03 sub=1 infile=%s%siter%sOld.H outfile=%s%siter%s.H >/dev/null"%(sbin,datax,dirrr,i,iter,dirrr,i,iter)
		#print C1
		#print C2
		os.system("echo '%s' >> %s"%(C1,cmdfile))
		os.system("echo '%s' >> %s"%(C2,cmdfile))
		cmd1 = "pycode/pyWritePBSsep.py %s %s %s %s %s%s %s"%(1,8,'24:00:00','2gb',jobname,i,cmdfile)
		os.system( cmd1)
	waitforjob(jobname,logdir,1800)

	return
# ###################################

def removefiles(maindir,iter,plet):

	dirgg = maindir + "/gg/ggDei%s"%(plet)
	dirss = maindir + "/ss/ssDei%s"%(plet)
	dirrr = maindir + "/rr/rrDei%s"%(plet)
	dirs  = maindir + "/s/sDei%s"%(plet)
	dirm  = maindir + "/m/mDei%s"%(plet)
	dirdm = maindir + "/dm/dmDei%s"%(plet)
	d1BK = dirdm + "BK"
	os.system("rm -f "+maindir+"/alpha.txt")
	
	for i in rmlist[:]:
		shot = i
		# Erase all the dmD%.H file after each BK is calculated
  		os.system("python pycode/pyRemove.py "+dirdm+`shot`+"iter"+`iter`+".H ") 

  	# Erase all the dmDBK%.H file after Total is calculated
	os.system("python pycode/pyRemove.py "+d1BK+"*.H")

	
	# Erase old rr, gg, and ss, unless request to be saved    
	for i in rmlist[:]:
		shot = i
		os.system("python pycode/pyRemove.py "+dirgg+`shot`+"iter"+`iter`+".H ")
		os.system("python pycode/pyRemove.py "+dirss+`shot`+"iter"+`iter`+".H ")
		os.system("python pycode/pyRemove.py "+dirrr+`shot`+"iter"+`iter`+".H ")
	
	# Erase old m, dm, and s
	os.system("python pycode/pyRemove.py "+dirs+"Total"+"iter"+`iter`+".H ")
	os.system("python pycode/pyRemove.py "+dirm+"Total"+"iter"+`iter`+".H ")
	os.system("python pycode/pyRemove.py "+dirdm+"Total"+"iter"+`iter`+".H ")
			
	return		
