# A script that does conjugate gradient calculations
#! /usr/bin/env python
#from SEP import *
import commands,re,string,sys,os
import datetime
import sys
import subprocess
sys.path.append('./pycode')
from pyBath import *
from pyInvmodRegJoint import *


projdir = sys.argv[1]
plet    = sys.argv[2]
iter  = int(sys.argv[3])
datax = int(sys.argv[4])
modax = int(sys.argv[5])
dirdm   = sys.argv[6]
dirggm   = sys.argv[7]
dirgg   = sys.argv[8]
dirrr   = sys.argv[9]
dirrrm   = sys.argv[10]
dirss   = sys.argv[11]
dirssm   = sys.argv[12]

# initialization
ggdrr = 0.
ggdgg = 0.
ssdss = 0.
ssdrr = 0.
ssdgg = 0.
resid = 0.
dmDdm = [0.,0.,0.,0.,0.,0.,0.];
ggmdrrm = [0.,0.,0.,0.,0.,0.,0.];
ggmdggm = [0.,0.,0.,0.,0.,0.,0.];
ssmdssm = [0.,0.,0.,0.,0.,0.,0.];
ssmdrrm = [0.,0.,0.,0.,0.,0.,0.];
ssmdggm = [0.,0.,0.,0.,0.,0.,0.];
residm = [0.,0.,0.,0.,0.,0.,0.];
ggDdrrD = [0.,0.,0.,0.,0.,0.,0.];
ggDdggD = [0.,0.,0.,0.,0.,0.,0.];
ssDdssD = [0.,0.,0.,0.,0.,0.,0.];
ssDdrrD = [0.,0.,0.,0.,0.,0.,0.];
ssDdggD = [0.,0.,0.,0.,0.,0.,0.];
residD = [0.,0.,0.,0.,0.,0.,0.];
# Calculagte residual in model space
# Calculate ddmDddm
os.system('rm -f '+projdir+'/temp.txt')
cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%sTotaliter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirdm,iter,projdir)
os.system(cmd1)
f2 = open(projdir+'/temp.txt', 'r')
str1 = f2.readline()
DPsum(float(str1),dmDdm)     
# Calculate ggmdggm
os.system('rm -f '+projdir+'/temp.txt')
cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirggm,iter,projdir)
os.system(cmd1)
f2 = open(projdir+'/temp.txt', 'r')
str1 = f2.readline()
DPsum(float(str1), ggmdggm)      
# calculate ggmdrrm
os.system('rm -f '+projdir+'/temp.txt')
cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%siter%s.H file2=%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirggm,iter,dirrrm,iter,projdir)
os.system(cmd1)
f2 = open(projdir+'/temp.txt', 'r')
str1 = f2.readline()
DPsum(float(str1), ggmdrrm)
       # calculate ggmdssm
os.system('rm -f '+projdir+'/temp.txt')
cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%siter%s.H file2=%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirggm,iter,dirssm,iter,projdir)
os.system(cmd1)
f2 = open(projdir+'/temp.txt', 'r')
str1 = f2.readline()
DPsum(float(str1), ssmdggm)
# Calculate ssmdssm
os.system('rm -f '+projdir+'/temp.txt')
cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirssm,iter,projdir)
os.system(cmd1)
f2 = open(projdir+'/temp.txt', 'r')
str1 = f2.readline()
DPsum(float(str1), ssmdssm)
# calculate ssmdrrm
os.system('rm -f '+projdir+'/temp.txt')
cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%siter%s.H file2=%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirssm,iter,dirrrm,iter,projdir)
os.system(cmd1)
f2 = open(projdir+'/temp.txt', 'r')
str1 = f2.readline()
DPsum(float(str1),ssmdrrm)
# Calculate rrmdrrm
os.system('rm -f '+projdir+'/temp.txt')
cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirrrm,iter,projdir)
os.system(cmd1)
f2 = open(projdir+'/temp.txt', 'r')
str1 = f2.readline()
DPsum(float(str1), residm)

# Dot products of data space Residual
for i in K[:]:
	shot=i

	# calculating ggdgg
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirgg+"up",shot,iter,projdir)
	os.system(cmd1)
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	DPsum(float(str1), ggDdggD)
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirgg+"dn",shot,iter,projdir)
	os.system(cmd1)
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	DPsum(float(str1), ggDdggD)
        # Calculating ggdrr
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%s%siter%s.H file2=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirgg+"up",shot,iter,dirrr+"up",shot,iter,projdir)
	os.system(cmd1)
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	DPsum(float(str1), ggDdrrD)
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%s%siter%s.H file2=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirgg+"dn",shot,iter,dirrr+"dn",shot,iter,projdir)
	os.system(cmd1)
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	DPsum(float(str1), ggDdrrD)
	# calculating ssdss
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirss+"up",shot,iter,projdir)
	os.system(cmd1)
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	DPsum(float(str1), ssDdssD)
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirss+"dn",shot,iter,projdir)
	os.system(cmd1)
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	DPsum(float(str1), ssDdssD)
	# calculating rrdrr
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirrr+"up",shot,iter,projdir)
	os.system(cmd1)
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	DPsum(float(str1), residD)
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirrr+"dn",shot,iter,projdir)
	os.system(cmd1)
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	DPsum(float(str1), residD)
	# Calculating ssdrr
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%s%siter%s.H file2=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin, datax,dirss+"up",shot,iter,dirrr+"up",shot,iter,projdir)
	os.system(cmd1)
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	DPsum(float(str1), ssDdrrD)
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%s%siter%s.H file2=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin, datax,dirss+"dn",shot,iter,dirrr+"dn",shot,iter,projdir)
	os.system(cmd1)
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	DPsum(float(str1), ssDdrrD)
	# Calculating ssdgg
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%s%siter%s.H file2=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin, datax,dirss+"up",shot,iter,dirgg+"up",shot,iter,projdir)
	os.system(cmd1)
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	DPsum(float(str1), ssDdggD)
	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=0 naxis=%s file1=%s%siter%s.H file2=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin, datax,dirss+"dn",shot,iter,dirgg+"dn",shot,iter,projdir)
	os.system(cmd1)
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	DPsum(float(str1), ssDdggD)


ggdgg = ggDdggD[6] + ggmdggm[6]
ggdrr = ggDdrrD[6] + ggmdrrm[6]
ssdss = ssDdssD[6] + ssmdssm[6]
ssdrr = ssDdrrD[6] + ssmdrrm[6]
ssdgg = ssDdggD[6] + ssmdggm[6]
resid = residD[6]  + residm[6]
# CG step to calculate alpha and beta
os.system("rm -f "+projdir+"/alpha.txt")
print 'before modcgstep';
cmd1 = "%s/modcgstep.x Forget=0 ggdgg=%s ggdrr=%s ssdss=%s ssdrr=%s ssdgg=%s outtag='%s/alpha.txt' >/dev/null "%(sbin,ggdgg,ggdrr,ssdss,ssdrr,ssdgg,projdir)
os.system(cmd1)
f = open(projdir+"/alpha.txt")
alpha = float(f.readline())
beta  = float(f.readline())
f.close()


# Saves the residual in data space
file = open(projdir+"/ResidualData.txt","a")
cmd1 = "%s %s %s %s %s %s %s \n "%(iter, ggDdggD[6], ggDdrrD[6], ssDdssD[6], ssDdrrD[6], ssDdggD[6], residD[6])
file.writelines(cmd1);
file.close()
# Saves the residual in model space
file = open(projdir+"/ResidualModel.txt","a")
cmd1 = "%s %s %s %s %s %s %s \n "%(iter, ggmdggm[6], ggmdrrm[6], ssmdssm[6], ssmdrrm[6], ssmdggm[6], residm[6])
file.writelines(cmd1);
file.close()
# Saves the total residual
file = open(projdir+"/ResidualTotal.txt","a")
cmd1 = "%s %s %s %s %s %s %s \n "%(iter, ggdgg, ggdrr, ssdss, ssdrr, ssdgg, resid)
file.writelines(cmd1);
file.close()

# Saves the percent residual
file = open(projdir+"/ResidualPercent.txt","a")
cmd1 = "%s %s %s %s %s %s %s \n "%(iter, str(round(ggmdggm[6]/ggdgg*100,2)), str(round(ggmdrrm[6]/ggdrr*100,2)), str(round(ssmdssm[6]/ssdss*100,2)), str(round(ssmdrrm[6]/ssdrr*100,2)), str(round(ssmdggm[6]/ssdgg*100,2)), str(round(residm[6]/resid*100,2)))
file.writelines(cmd1);
file.close()

# Save the alpha, beta, and residual
file = open(projdir+'/Reportsave.txt', 'a')
cmd1 = " %s %s %s %s %s %s %s \n"%(iter,alpha,beta, dmDdm[6], residD[6], residm[6], resid)
file.writelines(cmd1);
file.close()

