#! /usr/bin/env python
#from SEP import *
import commands as cmd
import re,string
import sys, os
import os.path as path
import fileinput
sys.path.append('./pycode')
from pyBath import *


nnode = 100  # max number of jobs to run simultaneously
jmax  = 2000 # max amount of 20 sec to wait before qutting
sbin = "./Bin"
sepbin="/usr/local/SEP/Bin"
#-------------------------------------------------------------

def waitforjob(jobnameMain,logdir,TotalMin):

	j=0
	while (j <= TotalMin*3):
		os.system("rm -f "+logdir+"/check."+jobnameMain)
		cmd2= "qstat  | grep \"mandyman\" | grep \"C sep\" -v | grep \"C default\" -v |grep \"%s\" -c  >> %s/check.%s"%(jobnameMain,logdir,jobnameMain)
		#print cmd2
		os.system(cmd2)
		f = open(logdir+'/check.'+jobnameMain)
		PEN = int(f.readline())
		if ((PEN) >= 1):
			if (j%3 == 1):
				stg2 = "%s; pending=%s, Time %s mins"%(jobnameMain, PEN,j/3)
				print stg2
			os.system('sleep 20')
			j=j+1
		else:
			break;

	if (j >= TotalMin*3):    # waited too long, quit job
		print 'waited too long, quit job'
		sys.exit('exit now to quit job')

#------------------------------------------------------------------------------------

def Ratio(maindir,projdir,plet,K,Rname,regParm, modax,datax,iter):

	dirdm = projdir+"/dm/dmDei"+plet
	dirggm = projdir+'/ggm/ggmDei'+plet	
	dirgg = projdir+'/gg/ggDei'+plet	
	ggmdggm = [0.,0.,0.,0.,0.,0.,0.];
	ggDdggD = [0.,0.,0.,0.,0.,0.,0.];

        cmd1 = "Bin/%s adj=0 par=%s eps=1.0 infile=%sTotaliter%s.H outfile=%sTemp.H >/dev/null"%(Rname, regParm, dirdm,iter,dirggm)
	print cmd1
        os.system(cmd1)

	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "Bin/Solver_ops.x cg=1 naxis=%s file1=%sTemp.H outfile=%s/temp.txt >&/dev/null"%(modax,dirggm,projdir)
	print cmd1
	os.system(cmd1)	
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	DPsum(float(str1),ggmdggm)
	os.system('python pycode/myRM.py %sTemp.H'%(dirggm))

        # calculating residual in data space
	for i in K[:]:

		# calculating ggdgg 
		os.system('rm -f '+projdir+'/temp*.txt')
		cmd1 = "Bin/Solver_ops.x cg=1 naxis=%s file1=%sup%siter%s.H outfile=%s/temp1.txt >&/dev/null"%(datax,dirgg,i,iter,projdir)
		print cmd1
		os.system(cmd1)	
		f2 = open(projdir+'/temp1.txt', 'r')
		str1 = f2.readline()
		DPsum(float(str1),ggDdggD)
		cmd1 = "Bin/Solver_ops.x cg=1 naxis=%s file1=%sdn%siter%s.H outfile=%s/temp2.txt >&/dev/null"%(datax,dirgg,i,iter,projdir)
		print cmd1
		os.system(cmd1)	
		f2 = open(projdir+'/temp2.txt', 'r')
		str1 = f2.readline()
		DPsum(float(str1),ggDdggD)


	# Calculate the ratio
	if (ggmdggm > 0.):
		ratio = (ggDdggD[6]/ggmdggm[6])**(0.5)
	else:
		ratio = 1.

	print 'Ratio calculation for iter', iter
	print 'ggmDggm ggDdggD', ggmdggm[6], ggDdggD[6]
	print 'ratio', ratio


	return ratio

############################################################################
def checkjob(jobname,projdir,logdir,outfile,iter,K):


	print 'checkjob:', jobname, logdir,outfile

	j=0
	while (j <= jmax):
		os.system("rm -f "+logdir+"/check."+jobname)
		cmd2= "qstat  | grep \"mandyman\" | grep \"C sep\" -v | grep \"C default\" -v|  grep \"%s\" -c  >> %s/check.%s"%(jobname,logdir,jobname)
		os.system(cmd2)
		f = open(logdir+'/check.'+jobname)
		PEN = int(f.readline())
		if (PEN >= 1):
			stg2 = "pending/running %s jobs: %s "%(jobname, PEN)
			print stg2
			if (j%3 == 1):
				 print 'checkjob for', jobname,'waited for', j/3, 'mins' 
			os.system('sleep 20')
			j=j+1
		else:
			break;

        # -----------------------------------------------------------
        #---- Check rather all the output file exist ----------------
        # -----------------------------------------------------------
	print 'checkjob: check rather all output file exist'
	status = []
	for i in range(1,len(K)+1):
		shot = K[i-1]
		status.append(i)
		searchname = "%s%siter%s.H"%(outfile,shot,iter)
		print 'searching for filename:', searchname
		lenn = len(searchname)
		os.system("${SEPBIN}/In %s | grep \"in=\" >> %s/CKout%siter%s.txt"%(searchname, logdir, shot,iter))
		file = open("%s/CKout%siter%s.txt"%(logdir, shot,iter))
		line = file.readline()
		pos=line.find("in=")
		binaryfile = line[pos+3:len(line)-1]
		#print "binary", binaryfile
		os.system('rm -r %s/CKout%siter%s.txt'%(logdir, shot,iter))
		if (not os.path.exists(binaryfile)):
			stg2 = 'Adjoint3D: shot %s iter %s not done'%(shot,iter)
			print stg2
		else:
			print 'file exist:', searchname
			status[i-1] = 0.;

	if (sum(status) == 0. ):
		print 'Jobname',jobname,'for iter # ',iter,' is finished sucessfully'
	else:
		print "Not all job is finish for',jobname, 'iter#", iter
		print "print job status"
		print K
		print status
		print sys.exit("Exit now")

	return

#############################################################################

def Adjoint(maindir, projdir, velfile, parfile, plet, smooth, lpfil, VDer, gauss, DW, souwfld1,souwfld2, MWfile1, MWfile2, DWfile1, DWfile2, Rname, regParm, eps,ratio, modax, nhx, iter):

	jobname1 = "L2%s_Adj%sup"%(plet,iter)
	jobname2 = "L2%s_Adj%sdn"%(plet,iter)
	jobscpt = maindir + '/pyJoint2/pyAdjoint3DJoint.py'
        outdir = projdir+'/dm'

        dirrr1 = projdir + '/rr/rrDei'+plet+"up"
        dirrr2 = projdir + '/rr/rrDei'+plet+"dn"
        dm1    = projdir + '/dm/dmDei'+plet+"up"
        dm2    = projdir + '/dm/dmDei'+plet+"dn"
        dmm    = projdir + '/dm/dmMDei'+plet
        dirrrm = projdir + '/rrm/rrmDei'+plet

	os.system('rm %s/JN/JNAdj%siter%s.txt'%(projdir,plet,iter))
	# -----------------------------------------------------------
        #---- First calculate eps A' Rm  ----------------------------
        # -----------------------------------------------------------
        # Set ramping of the eps from zero to maxeps over 5 iterations
        ramp=[1.0,1.0,1.0,1.0]

        
        if iter <= len(ramp):
        	EPS = ramp[iter-1]*eps*ratio
        	print 'EPS, ramp[iter-1], eps, ratio', EPS, ramp[iter-1], eps, ratio
        else:
        	EPS = eps*ratio
        
        cmd1 = "Bin/%s adj=1 par=%s eps=%s infile=%siter%s.H outfile=%siter%s.H >/dev/null "%(Rname, regParm, EPS, dirrrm,iter,dmm,iter)
        os.system(cmd1)

	# -----------------------------------------------------------
        #---- Run the jobs  -----------------------------------------
        # -----------------------------------------------------------
	for i in range(1,len(K)+1):
        	shot = K[i-1]
		os.system("sleep 2")
		jobnameInd = jobname1+'_%s'%(shot)	
		print 'Adjoint: submitting job #', jobnameInd
		stg1 = '%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s&'%(jobscpt,shot,jobnameInd, iter, outdir,projdir,plet, velfile, parfile, smooth, lpfil, VDer, gauss, DW, nhx, souwfld1,MWfile1, DWfile1, dirrr1, dm1, 1)
		print stg1
		os.system(stg1)
		os.system("sleep 2")
		jobnameInd = jobname2+'_%s'%(shot)	
		print 'Adjoint: submitting job #', jobnameInd
		stg1 = '%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s&'%(jobscpt,shot,jobnameInd, iter, outdir,projdir,plet, velfile, parfile, smooth, lpfil, VDer, gauss, DW, nhx, souwfld2,MWfile2, DWfile2, dirrr2, dm2, 2)
		print stg1
		os.system(stg1)
		#sys.exit('exit to debug Adjoint')

	# -----------------------------------------------------------
        #---- Check rather all the output file exist ----------------
        # -----------------------------------------------------------
	checkjob(jobname1,projdir,outdir,dm1,iter,K)	
	checkjob(jobname2,projdir,outdir,dm2,iter,K)			
	
	# -----------------------------------------------------------
	# ---- Sum the individual up and dn file into one -----------
	# -----------------------------------------------------------
	for i in range(1,len(K)+1):
		outfile = outdir+ "/dmDei"+plet
		
		updmfile = "%s%siter%s.H"%(dm1,i,iter)
		dndmfile = "%s%siter%s.H"%(dm2,i,iter)

		cmd1 = "Bin/SUMMING.x naxis=%s nfile=2 outfile=%s%siter%s.H file1=%s file2=%s >/dev/null "%(modax,outfile,i,iter,updmfile,dndmfile)
		print cmd1
		os.system(cmd1)

 		searchname = "%s%siter%s.H"%(outfile,i,iter)
		print 'searching for filename:', searchname
		lenn = len(searchname)
		token = searchname[lenn-6:]

		os.system("%s/In %s | grep \"in=\" >> %s/CKout%s.txt"%(sepbin, searchname, outdir, token))
		file = open("%s/CKout%s.txt"%(outdir, token))
		line = file.readline()
		pos=line.find("in=")
		binaryfile = line[pos+3:len(line)-1]
		print "binary", binaryfile
		os.system('rm -r %s/CKout%s.txt'%(outdir, token))
		if (not os.path.exists(binaryfile)):
			stg2 = 'Adjoint3DJoint: shot %s iter %s not done'%(i,iter)   
			sys.exit("exit for debug please")
		else:

			# Remove the dmup and dm-down file
			os.system("python pycode/pyRemove.py %s%siter%s.H %s%siter%s.H"%(dm1,i,iter,dm2,i,iter))



	return


#############################################################################

def Forward(maindir, projdir, velfile, parfile, plet, smooth, lpfil, VDer, gauss, DW, souwfld1, souwfld2, MWfile1, MWfile2, DWfile1, DWfile2, Rname, regParm, eps,ratio, modax, nhx, iter):

	jobname1 = "L2%s_For%sup"%(plet,iter)
	jobname2 = "L2%s_For%sdn"%(plet,iter)
	jobscpt = maindir + '/pyJoint2/pyForward3DJoint.py'
	outdir=projdir+'/gg'

	dirdm = projdir+"/dm/dmDei"+plet
	dirggm = projdir+'/ggm/ggmDei'+plet	
	dirgg1 = projdir+'/gg/ggDei'+plet+"up"
	dirgg2 = projdir+'/gg/ggDei'+plet+"dn"

	#reflfile=projdir+"/dm/dmDei"+plet+"Totaliter%s.H"%(iter)
	#outfile1 = outdir+"/ggDei"+plet+"up"
	#outfile2 = outdir+"/ggDei"+plet+"dn"
	#j = 1  # initialization

	# -----------------------------------------------------------
        #---- First, calculate ggm - eps A dm  ----------------------
        # -----------------------------------------------------------
        # Set ramping of the eps from zero to maxeps over 5 iterations
        ramp=[1.0,1.0,1.0,1.0]

        if iter <= len(ramp):
        	EPS = ramp[iter-1]*eps*ratio
        else:
        	EPS = eps*ratio

	cmd1 = "Bin/%s adj=0 par=%s eps=%s infile=%sTotaliter%s.H outfile=%siter%s.H >/dev/null"%(Rname, regParm, EPS, dirdm,iter,dirggm,iter)
        os.system(cmd1)


	# -----------------------------------------------------------
        #---- Run the jobs  -----------------------------------------
        # -----------------------------------------------------------
	for i in range(1,len(K)+1):
        	shot = K[i-1]
		os.system("sleep 2")
		jobnameInd = jobname1+'_%s'%(shot)	
		print 'Forward: submitting job #', jobnameInd
		stg1 = '%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s 1 &'%(jobscpt,shot,jobnameInd, iter, outdir,projdir,plet, velfile, parfile, smooth, lpfil, VDer, gauss, DW, nhx, souwfld1,MWfile1, DWfile1, dirgg1, dirdm)
		os.system(stg1)
		os.system("sleep 2")
		jobnameInd = jobname2+'_%s'%(shot)	
		print 'Forward: submitting job #', jobnameInd
		stg1 = '%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s 2 &'%(jobscpt,shot,jobnameInd, iter, outdir,projdir,plet, velfile, parfile, smooth, lpfil, VDer, gauss, DW, nhx, souwfld2,MWfile2, DWfile2, dirgg2, dirdm)
		os.system(stg1)
	
	# -----------------------------------------------------------
        #---- Check rather all the output file exist ----------------
        # -----------------------------------------------------------
	checkjob(jobname1,projdir,outdir,dirgg1,iter,K)	
	checkjob(jobname2,projdir,outdir,dirgg2,iter,K)	

	 			
	return

		
		
	


# ####################################

def Add(maindir,projdir, d1,  iter, naxis, plet,dmm,dirdm):
	# naxis: number of axes in files to be summed
        d1BK=d1+"BK"
	outdir = projdir+'/dm'

	scpt = 'pyJoint2/pyAddrtm.py'
	stg1 = '%s %s %s %s %s %s %s %s'%(scpt,outdir,d1,iter,naxis,plet,dmm,dirdm)
	print stg1
	os.system(stg1)

	#wait for job to finish (have the exact same jobname as specified in pyAddrtm.py'
	jobname='Add%s%s'%(plet,iter)
	waitforjob(jobname,outdir,1800)
	
		# Now check if final output file exist
	# If so, erase all intermediate outputs (except for a selected few)
	searchname = "%sSUMiter%s.H"%(d1,iter)
	print 'searching for filename:', searchname
	lenn = len(searchname)
	os.system("${SEPBIN}/In %s | grep \"in=\" >> %s/CKoutTotaliter%s.txt"%(searchname, outdir,iter))
	file = open("%s/CKoutTotaliter%s.txt"%(outdir,iter))
	line = file.readline()
	pos=line.find("in=")
	binaryfile = line[pos+3:len(line)-1]
	#print "binary", binaryfile
	os.system('rm -r %s/CKoutTotaliter%s.txt'%(outdir,iter))
	if (not os.path.exists(binaryfile)):
		stg2 = 'Add rtm : plet %s iter %s not done'%(plet,iter)
		sys.exit('Add rtm files failed, exit')

#	# Start erasing intermediate files
#	print 'len EK'
#	for i in EK[:]:
#        	cmd1 = 'python pycode/pyRemove.py %s%siter%s.H'%(d1,i,iter)
#		os.system(cmd1)

	
	return
# ####################################	
# add the DP by accumulated sum
def DPsum( number, varname):
	# 0=tmpP, 1=errP, 2=totP, 3=tmpM, 4=errM, 5=totM, 6=tot
#	print 'number', number
#	print 'varname', varname

	if ( number > 0.00000):
		varname[0] = varname[2] + number + varname[1]
		varname[1] = (varname[2]-varname[0])+number
		varname[2] = varname[0] 
	else:
		varname[3] = varname[5] + number + varname[4]
		varname[4] = (varname[5]-varname[3])+number
		varname[5] = varname[3] 

	varname[6] = varname[5] + varname[2]

# ####################################
# Test function

def testDP():

	ssum = [0.,0.,0.,0.,0.,0.,0.];    
	print 'ssum', ssum
	for i in range(0, 10):
		val = 3.14159*i
		print i, val

		DPsum(val, ssum)

	print 'final sum', ssum[6]


# ####################################	
# Calculate the alpha only using double precision

def DPcalCG(projdir, plet,iter,datax, modax, dirdm, dirggm, dirgg, dirrr, dirrrm):

	cmdfile ='%s/pbs/DPcalCGiter%s.txt'%(projdir,iter)
	logfile = '%s/pbs/logfile'%(projdir)
	jobname = 'DP%s_%s'%(plet,iter)

	os.system('rm -f %s'%(cmdfile))
	cmd1 = 'python pyJoint2/pyDPcalCG.py %s %s %s %s %s %s %s %s %s %s'%(projdir,plet,iter,datax,modax,dirdm,dirggm,dirgg,dirrr,dirrrm)
	print cmd1
	os.system("echo '%s' >> %s"%(cmd1,cmdfile))


	# Submit job and wait until it is done
	cmd1 = "pycode/pyWritePBSsep.py %s %s %s %s %s %s"%(1,8,'24:00:00','2gb',jobname,cmdfile)
	os.system( cmd1)
	waitforjob(jobname,logfile,1800)

	# initialize alpha and beta
	alpha=0.
	beta=0.

	# read the alpha values
        f = open(projdir+"/alpha.txt")
        alpha = float(f.readline())
        beta = 0.
        f.close()
	os.system('rm -f %s/alpha.txt'%(projdir))

	return alpha, beta

# ####################################	
# Calculate the alpha and beta using double precision

def DPcalCD(projdir, plet,iter,datax,modax, dirdm, dirggm, dirgg, dirrr, dirrrm, dirss, dirssm):

	cmdfile ='%s/pbs/DPcalCDiter%s.txt'%(projdir,iter)
	logdir = '%s/pbs/logfile'%(projdir)
	jobname = 'DP%s_%s'%(plet,iter)

	os.system('rm -f %s'%(cmdfile))
	cmd1 = 'python pyJoint2/pyDPcalCD.py %s %s %s %s %s %s %s %s %s %s %s %s'%(projdir,plet,iter,datax,modax,dirdm,dirggm,dirgg,dirrr,dirrrm,dirss,dirssm)
	print cmd1
	os.system("echo '%s' >> %s"%(cmd1,cmdfile))

	# Submit job and wait until it is done
	cmd1 = "pycode/pyWritePBSsep.py %s %s %s %s %s %s"%(1,8,'24:00:00','2gb',jobname,cmdfile)
	os.system( cmd1)
	waitforjob(jobname,logdir,1800)

	# initialize alpha and beta
	alpha=0.
	beta=0.

        # Read the alpha and beta values
	f = open(projdir+"/alpha.txt")
	os.system('more %s/alpha.txt"'%(projdir))
	alpha = float(f.readline())
	beta  = float(f.readline())
	f.close()	
	os.system("rm -f "+projdir+"/alpha.txt")

	return alpha, beta


# ####################################
def ResidCal(projdir, plet, K,iter,datax, dirrr):
	resid = 0.
	for i in K[:]:

		# calculating rrdrr
		os.system('rm -f '+projdir+'/temp*.txt')
		cmd1 = "Bin/Solver_ops.x cg=1 naxis=%s file1=%sup%siter%s.H outfile=%s/temp1.txt >&/dev/null"%(datax,dirrr,i,iter,projdir)
		print cmd1
		os.system(cmd1)	
		f2 = open(projdir+'/temp1.txt', 'r')
		str1 = f2.readline()
		resid = resid + float(str1)
		cmd1 = "Bin/Solver_ops.x cg=1 naxis=%s file1=%sdn%siter%s.H outfile=%s/temp2.txt >&/dev/null"%(datax,dirrr,i,iter,projdir)
		print cmd1
		os.system(cmd1)	
		f2 = open(projdir+'/temp2.txt', 'r')
		str1 = f2.readline()
		resid = resid + float(str1)
		
	return resid

# ###################################
# make a copy of current residual (rr)
# compare the current residual with from iter 1
# Remove the value that was amost statics
def EraseStatic(iter,refiter,datax,dirrr):
	# make a copy of current residual
	for i in K[:]:
		C1a = "%s/updateAB.x alpha=1.0 cg=1 naxis=%s file1=%sup%siter%s.H outfile=%sup%siter%sOld.H >/dev/null"%(sbin,datax,dirrr,i,iter,dirrr,i,iter)
		C1b = "%s/updateAB.x alpha=1.0 cg=1 naxis=%s file1=%sdn%siter%s.H outfile=%sdn%siter%sOld.H >/dev/null"%(sbin,datax,dirrr,i,iter,dirrr,i,iter)
		#print C1a	
		os.system(C1a)
		os.system(C1b)
	# run samevalue
		C2a = "%s/SameValue.x naxis=%s eps=0.02 infile1=%sup%siter%sOld.H infile2=%sup%siter%s.H outfile=tmpSameup%siter%sV1.H >/dev/null"%(sbin,datax,dirrr,i,iter,dirrr,i,refiter,i,iter)
		C3a = "%s/SameValue.x naxis=%s eps=0.02 infile1=tmpSameup%siter%sV1.H infile2=%sup%siter%s.H outfile=tmpSameup%siter%sV2.H >/dev/null"%(sbin,datax,i,iter,dirrr,i,refiter,i,iter)
		C4a = "%s/SameValue.x naxis=%s eps=0.02 infile1=tmpSameup%siter%sV2.H infile2=%sup%siter%s.H outfile=tmpSameup%siter%sV3.H >/dev/null"%(sbin,datax,i,iter,dirrr,i,refiter,i,iter)
		C5a = "%s/SameValue.x naxis=%s eps=0.02 infile1=tmpSameup%siter%sV3.H infile2=%sup%siter%s.H outfile=tmpSameup%siter%sV4.H >/dev/null"%(sbin,datax,i,iter,dirrr,i,refiter,i,iter)
		C6a = "%s/SameValue.x naxis=%s eps=0.02 sub=1 infile1=%sup%siter%sOld.H infile2=tmpSameup%siter%sV4.H outfile=%sup%siter%s.H >/dev/null"%(sbin,datax,dirrr,i,iter,dirrr,i,dirrr,i,iter)
		C2b = "%s/SameValue.x naxis=%s eps=0.02 infile1=%sdn%siter%sOld.H infile2=%sdn%siter%s.H outfile=tmpSamedn%siter%sV1.H >/dev/null"%(sbin,datax,dirrr,i,iter,dirrr,i,refiter,i,iter)
		C3b = "%s/SameValue.x naxis=%s eps=0.02 infile1=tmpSamedn%siter%sV1.H infile2=%sdn%siter%s.H outfile=tmpSamedn%siter%sV2.H >/dev/null"%(sbin,datax,i,iter,dirrr,i,refiter,i,iter)
		C4b = "%s/SameValue.x naxis=%s eps=0.02 infile1=tmpSamedn%siter%sV2.H infile2=%sdn%siter%s.H outfile=tmpSamedn%siter%sV3.H >/dev/null"%(sbin,datax,i,iter,dirrr,i,refiter,i,iter)
		C5b = "%s/SameValue.x naxis=%s eps=0.02 infile1=tmpSamedn%siter%sV3.H infile2=%sdn%siter%s.H outfile=tmpSamedn%siter%sV4.H >/dev/null"%(sbin,datax,i,iter,dirrr,i,refiter,i,iter)
		C6b = "%s/SameValue.x naxis=%s eps=0.02 sub=1 infile1=%sdn%siter%sOld.H infile2=tmpSamedn%siter%sV4.H outfile=%sdn%siter%s.H >/dev/null"%(sbin,datax,dirrr,i,iter,dirrr,i,dirrr,i,iter)
		#print C2
		#print C3
		#print C4
		#print C5
		#print C6
		os.system(C2a)
		os.system(C3a)
		os.system(C4a)
		os.system(C5a)
		os.system(C6a)
		os.system(C2b)
		os.system(C3b)
		os.system(C4b)
		os.system(C5b)
		os.system(C6b)
		C7 = "python pycode/pyRemove.py tmpSameup%siter%sV1.H tmpSameup%siter%sV2.H tmpSameup%siter%sV3.H tmpSameup%siter%sV4.H tmpSamedn%siter%sV1.H tmpSamedn%siter%sV2.H tmpSamedn%siter%sV3.H tmpSamedn%siter%sV4.H"%(i,iter,i,iter,i,iter,i,iter)
		print C7
		os.system(C7)
	return

# ###################################

def removefiles(maindir,iter,plet):

	dirgg = maindir + "/gg/ggDei%s"%(plet)
	dirss = maindir + "/ss/ssDei%s"%(plet)
	dirrr = maindir + "/rr/rrDei%s"%(plet)
	dirs  = maindir + "/s/sDei%s"%(plet)
	dirm  = maindir + "/m/mDei%s"%(plet)
	dirdm = maindir + "/dm/dmDei%s"%(plet)
	d1BK = dirdm + "BK"
	os.system("rm -f "+maindir+"/alpha.txt")
	
	for i in rmlist[:]:
		shot = i
		# Erase all the dmD%.H file after each BK is calculated
  		os.system("python pycode/pyRemove.py "+dirdm+`shot`+"iter"+`iter`+".H ") 

  	# Erase all the dmDBK%.H file after Total is calculated
	os.system("python pycode/pyRemove.py "+d1BK+"*.H")

	
	# Erase old rr, gg, and ss, unless request to be saved    
	for i in rmlist[:]:
		shot = i
		os.system("python pycode/pyRemove.py "+dirgg+`shot`+"iter"+`iter`+".H ")
		os.system("python pycode/pyRemove.py "+dirss+`shot`+"iter"+`iter`+".H ")
		os.system("python pycode/pyRemove.py "+dirrr+`shot`+"iter"+`iter`+".H ")
	
	# Erase old m, dm, and s
	os.system("python pycode/pyRemove.py "+dirs+"Total"+"iter"+`iter`+".H ")
	os.system("python pycode/pyRemove.py "+dirm+"Total"+"iter"+`iter`+".H ")
	os.system("python pycode/pyRemove.py "+dirdm+"Total"+"iter"+`iter`+".H ")
			
	return		
