#! /usr/bin/env python
#from SEP import *
import commands as cmd
import re,string
import sys, os
import os.path as path

# This code precompute and save the source wavefields

from pyBath import *


plet='E'

# where the output is saved
maindir = './MWfile/E'
nodes = 1   # number of nodes for each job
ppn=16     # number of processor per node
walltime='24:00:00'  # max time to wait for the job to finish
pmem = '2gb'  # max memory to allocate for the job


jobname = 'MWfile%s'%(plet)
outfile = maindir+'/mwDei'

parfile = 'Par/Pmwfile.par'
os.system("rm -f out1.par; sed '/#/d' %s | sed '/^$/d' | tr '\n' ' ' > out1.par"%(parfile))
f1 = open("out1.par")
param = f1.readline()
f1.close()
print 'param', param


#for i in [2]:	
for i in K[:]:
	if (os.path.isdir('%s/pbs'%(maindir)) != 1):
		os.system('mkdir %s/pbs'%(maindir))
	if (os.path.isdir('%s/logfile'%(maindir)) != 1):
		os.system('mkdir %s/logfile'%(maindir))
	cmdfile = "%s/pbs/PBS%s%s.txt"%(maindir,plet,i)
	logfile = "%s/logfile/rtm%s.txt"%(maindir,i)
	os.system("rm -f %s %s"%(cmdfile,logfile))

	print 'Submitting shot #', i
	cmd0 ='python pycode/pyRemove.py %s%s%s.H '%(outfile,plet,i)
	os.system("echo '%s' >> %s"%(cmd0,cmdfile))
	cmd1 = "Bin/offsetmask.x create=1 %s vel=6. zmute=100 outfile1=%s/mwDei%s%s.H >/dev/null"%(param,maindir,plet,i)
	os.system("echo '%s' >> %s"%(cmd1,cmdfile))

	# generate the pbs scripts 
	cmd1 = "pycode/pyWritePBSsep.py %s %s %s %s %s%s %s"%(nodes,ppn,walltime,pmem,jobname,i,cmdfile)
	os.system( cmd1)

flag=1

while (flag > 0):	
	# flag = number of job running
	os.system("qstat | grep \"mandyman\" | grep \"%s\" | grep \" C \" -v | grep \"C default\" -v -c >& %s/count.txt"%(jobname,maindir)) 
	f = open("%s/count.txt"%(maindir))
	os.system("rm -f %s/count.txt"%(maindir))
	flag = int(f.readline())	
	f.close()	
	os.system("rm -f %s/count.txt"%(maindir))
	print "Number of proc",flag,",not done yet, sleep 10"
	os.system("sleep 10")


print "Good bye!"
