#! /usr/bin/env python
#from SEP import *
import commands as cmd
import re,string
import sys, os
import os.path as path

# This code precompute and save the source wavefields

from pyBath import *


plet='G'
UD=2   # 1=up and 2=down

# where the output is saved
maindir = './rtm/G'
nodes = 1   # number of nodes for each job
ppn=16     # number of processor per node
walltime='24:00:00'  # max time to wait for the job to finish
pmem = '2gb'  # max memory to allocate for the job
jobname = 'MigDn%s'%(plet)

parfile = 'Par/PMigSddA.par'
os.system("rm -f out1.par; sed '/#/d' %s | sed '/^$/d' | tr '\n' ' ' > out1.par"%(parfile))
f1 = open("out1.par")
param = f1.readline()
f1.close()


dt=ForwardTime[0][0]
nt=ForwardTime[0][2*int(UD)-1]
ot=ForwardTime[0][2*int(UD)]

#for i in [13]:	
for i in K[:]:
	bfile = swfile[int(i)][2*int(UD)-1]
	efile = swfile[int(i)][2*int(UD)]
	# Get Source wfld file index
	if (os.path.isdir('%s/pbs'%(maindir)) != 1):
		os.system('mkdir %s/pbs'%(maindir))
	if (os.path.isdir('%s/logfile'%(maindir)) != 1):
		os.system('mkdir %s/logfile'%(maindir))
	cmdfile = "%s/pbs/PBS%s%s.txt"%(maindir,plet,i)
	logfile = "%s/logfile/rtm%s.txt"%(maindir,i)
	os.system("rm -f %s %s"%(cmdfile,logfile))

	print 'rtmE: submitting shot #', i
	cmd0 ='python pycode/pyRemove.py %s/rtmDei%s%s.H %s/rtmDeiAngle%s%s.H '%(maindir,plet,i,maindir,plet,i)
	cmd1 = "Bin/Mig_Main3D_Off.x velin=Input/velDeimos3D.H %s vmax=4500 nt=%s dt=%s ot=%s nodes=%s bfile=%s efile=%s wfldsou=souwfld/A/swDeiA%s.H  recfile=fiedat/B/fdDeiB%s.H MWfile=MWfile/mwconst.H wfmout=0 outtag=%s/rtmDei%s%s.H >& %s/logfile/rtm%s.log"%(param,nt,dt,ot,ppn,bfile,efile,i,i,maindir,plet,i,maindir,i)
	os.system("echo '%s' >> %s"%(cmd0,cmdfile))
	os.system("echo '%s' >> %s"%(cmd1,cmdfile))


	# generate the pbs scripts 
	cmd1 = "pycode/pyWritePBSsep.py %s %s %s %s %s%s %s"%(nodes,ppn,walltime,pmem,jobname,i,cmdfile)
	os.system( cmd1)
	submitted = 1
	os.system('sleep 2')


logdir=maindir+'/logfile/'
j=0
print 'wait for jobs to finish',j          
while (j <= 240):
        os.system("rm -f "+logdir+"/check."+jobname)
        cmd2= "qstat  | grep \"mandyman\" | grep \"C sep\" -v | grep \"C default\" -v |grep \"%s\" -c  >> %s/check.%s"%(jobname,logdir,jobname)
  #      print cmd2
        os.system(cmd2)
        f = open(logdir+'/check.'+jobname)
        PEN = int(f.readline())
        print PEN
        if (PEN >= 1):
                stg2 = "pending/running %s jobs: %s ; Time %s mins"%(jobname, PEN,j/3)
                print stg2
                os.system('sleep 20')
                j=j+1
        else:
                break;

        if (j >= 5000):    # waited too long, quit job
                print 'waited too long, quit job'
                sys.exit('exit now to quit job')



print "Good bye!"
