#! /usr/bin/env python
#from SEP import *
import commands as cmd
import re,string
import sys, os
import os.path as path

# This code precompute and save the source wavefields

from pyBath import *


plet='A'

# where the output is saved
maindir = 'souwfld/A'
nodes = 1   # number of nodes for each job
ppn=16     # number of processor per node
walltime='24:00:00'  # max time to wait for the job to finish
pmem = '2gb'  # max memory to allocate for the job


jobname = 'Dei_SW%sdn'%(plet)
progname = "Bin/SouGen3Ddn.x"
vfile = 'Input/velDeimos3D.H'
parmfile = 'Par/PswSddA.par'
soufile = 'Input/ricBP_2ms.H'
ampfile = maindir+'/ampDei'
ASout = 1
ASfile = maindir+'/ASDei'
outfile = maindir+'/swDei'

parfile = 'Par/PswSddA.par'
os.system("rm -f out1.par; sed '/#/d' %s | sed '/^$/d' | tr '\n' ' ' > out1.par"%(parfile))
f1 = open("out1.par")
param = f1.readline()
f1.close()


#for i in [2]:	
for i in K[:]:
	Gx = L[int(i)][1]
	Gy = L[int(i)][2]
	Gz = L[int(i)][3]
	if (os.path.isdir('%s/pbs'%(maindir)) != 1):
		os.system('mkdir %s/pbs'%(maindir))
	if (os.path.isdir('%s/logfile'%(maindir)) != 1):
		os.system('mkdir %s/logfile'%(maindir))
	cmdfile = "%s/pbs/PBS%s%s.txt"%(maindir,plet,i)
	logfile = "%s/logfile/rtm%s.txt"%(maindir,i)
	os.system("rm -f %s %s"%(cmdfile,logfile))

	print 'SW_A: submitting shot #', i
	cmd0 ='python pycode/pyRemove.py %s%s%s.H %s/tmp%s%s.H '%(outfile,plet,i,maindir,plet,i)
	os.system("echo '%s' >> %s"%(cmd0,cmdfile))
	cmd1 = "Bin/SouGen3Ddn.x vfile=\"%s\" %s Gx=%s Gy=%s Gz=%s vmax=4500 nodes=%s soufile='%s' ampfile='%s%s%s.H' ASout=%s asfile='%s%s%s.H' wfldout=0 outtag='%s%s%s.H' >& %s/logfile/sw%s.log"%(vfile,param,Gx,Gy,Gz,nodes,soufile,ampfile,plet,i,ASout,ASfile,plet,i,outfile,plet,i,maindir,i )
	os.system("echo '%s' >> %s"%(cmd1,cmdfile))

	# generate the pbs scripts 
	cmd1 = "pycode/pyWritePBSsep.py %s %s %s %s %s%s %s"%(nodes,ppn,walltime,pmem,jobname,i,cmdfile)
	os.system( cmd1)


flag=1

while (flag > 0):	
	# flag = number of job running
	os.system("qstat | grep \"mandyman\" | grep \"%s\" | grep \" C \" -v -c >& %s/count.txt"%(jobname,maindir)) 
	f = open("%s/count.txt"%(maindir))
	os.system("rm -f %s/count.txt"%(maindir))
	flag = int(f.readline())	
	f.close()	
	os.system("rm -f %s/count.txt"%(maindir))
	print "Number of proc",flag,",not done yet, sleep 10"
	os.system("sleep 10")


print "Good bye!"
