#! /usr/bin/env python
#from SEP import *
import commands as cmd
import re,string
import sys, os
import os.path as path
import fileinput
sys.path.append('./pycode')
from pyLoc import *

# Version two submit 4 jobs at a Arte in the current nodes

# -----------------------------------------------------------
#-----Define shots parameters ----------- *** NEED CHANGING ***
# -----------------------------------------------------------


nnode = 300  # max number of jobs to run simultaneously
jmax  = 100 # max amount of 20 sec to wait before qutting
sbin = "./bin"
#-------------------------------------------------------------

def waitforjob(jobnameMain,logdir,TotalMin):

	j=0
	while (j <= TotalMin*3):
		os.system("rm -f "+logdir+"/check."+jobnameMain)
		cmd2= "qstat  | grep \"mandyman\" | grep \"C sep\" -v |grep \"%s\" -c  >> %s/check.%s"%(jobnameMain,logdir,jobnameMain)
		os.system(cmd2)
		f = open(logdir+'/check.'+jobnameMain)
		PEN = int(f.readline())
		if (PEN >= 1):
			if (j%3 == 1):
				stg2 = "pending/running %s jobs: %s ; Time %s mins"%(jobnameMain, PEN,j/3)
				print stg2
			os.system('sleep 20')
			j=j+1
		else:
			break;

	if (j >= TotalMin*3):    # waited too long, quit job
		print 'waited too long, quit job'
		sys.exit('exit now to quit job')

	


def Ratio(maindir,projdir,plet,K,Rname,modax,datax,iter):

	dirdm = projdir+"/dm/dmArt"+plet
	dirggm = projdir+'/ggm/ggmArt'+plet	
	dirgg = projdir+'/gg/ggArt'+plet	
	ggmdggm = 0.
	ggDdggD = 0.

        cmd1 = "%s/%s adj=0 naxis=%s eps=1.0 infile=%sTotaliter%s.H outfile=%sTemp.H >/dev/null"%(sbin,Rname, modax, dirdm,iter,dirggm)
	print cmd1
        os.system(cmd1)

	os.system('rm -f '+projdir+'/temp.txt')
	cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%sTemp.H outfile=%s/temp.txt >&/dev/null"%(sbin,modax,dirggm,projdir)
	print cmd1
	os.system(cmd1)	
	f2 = open(projdir+'/temp.txt', 'r')
	str1 = f2.readline()
	ggmdggm = ggmdggm + float(str1)
	os.system('pycode/pyRemove.py %sTemp.H'%(dirggm))


        # calculating residual in data space
	for i in K[:]:
		shot = i
		# calculating ggdgg 
		os.system('rm -f '+projdir+'/temp.txt')
		cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirgg,shot,iter,projdir)
		print cmd1
		os.system(cmd1)	
		f2 = open(projdir+'/temp.txt', 'r')
		str1 = f2.readline()
		ggDdggD = ggDdggD + float(str1)

	# Calculate the ratio
	if (ggmdggm > 0.):
		ratio = (ggDdggD/ggmdggm)**(0.5)
	else:
		ratio = 1.

	print 'Ratio calculation for iter', iter
	print 'ggmDggm ggDdggD', ggmdggm, ggDdggD
	print 'ratio', ratio


	return ratio

############################################################################
def checkjob(jobname,projdir,logdir,outfile,iter,K):


	print 'checkjob:', jobname, logdir,outfile

	j=0
	while (j <= jmax):
		os.system("rm -f "+logdir+"/check."+jobname)
		cmd2= "qstat  | grep \"mandyman\" | grep \"C sep\" -v |  grep \"%s\" -c  >> %s/check.%s"%(jobname,logdir,jobname)
		os.system(cmd2)
		f = open(logdir+'/check.'+jobname)
		PEN = int(f.readline())
		if (PEN >= 1):
			stg2 = "pending/running %s jobs: %s "%(jobname, PEN)
			print stg2
			if (j%3 == 1):
				 print 'checkjob for', jobname,'waited for', j/3, 'mins' 
			os.system('sleep 20')
			j=j+1
		else:
			break;

        # -----------------------------------------------------------
        #---- Check rather all the output file exist ----------------
        # -----------------------------------------------------------
	print 'checkjob: check rather all output file exist'
	status = []
	for i in range(1,len(K)+1):
		shot = K[i-1]
		status.append(i)
		searchname = "%s%siter%s.H"%(outfile,shot,iter)
		print 'searching for filename:', searchname
		lenn = len(searchname)
		os.system("${SEPBIN}/In %s | grep \"in=\" >> %s/CKout%siter%s.txt"%(searchname, logdir, shot,iter))
		file = open("%s/CKout%siter%s.txt"%(logdir, shot,iter))
		line = file.readline()
		pos=line.find("in=")
		binaryfile = line[pos+3:len(line)-1]
		#print "binary", binaryfile
		os.system('rm -r %s/CKout%siter%s.txt'%(logdir, shot,iter))
		if (not os.path.exists(binaryfile)):
			stg2 = 'Adjoint3D: shot %s iter %s not done'%(shot,iter)
			print stg2
		else:
			print 'file exist:', searchname
			status[i-1] = 0.;

	if (sum(status) == 0. ):
		print 'Jobname',jobname,'for iter # ',iter,' is finished sucessfully'
	else:
		print "Not all job is finish for',jobname, 'iter#", iter
		print "print job status"
		print K
		print status
		print sys.exit("Exit now")

	return

#############################################################################

def Adjoint(maindir, projdir, velfile, parfile, plet, K, smooth, lpfil, VDer, gauss, DW, MWfile, DWfile, Rname, eps,ratio, modax, nhx, iter):

	jobname = "Adj%siter%s"%(plet,iter)
	jobscpt = maindir + '/pyinv1/pyAdjointOneDir.py'
	outdir = projdir+'/dm'
        dirrrm = projdir + '/rrm/rrmArt'+plet
        dmm    = projdir + '/dm/dmMArt'+plet
        dm    = projdir + '/dm/dmArt'+plet

	os.system('rm %s/JN/JNAdj%siter%s.txt'%(projdir,plet,iter))
	# -----------------------------------------------------------
        #---- First calculate eps A' pycode/pyRemove.py  ----------------------------
        # -----------------------------------------------------------
        # Set ramping of the eps from zero to maxeps over 5 iterations
        ramp=[0.2,0.4,0.6,0.8]
        
        if iter <= len(ramp):
        	EPS = ramp[iter-1]*eps*ratio
        	print 'EPS, ramp[iter-1], eps, ratio', EPS, ramp[iter-1], eps, ratio
        else:
        	EPS = eps*ratio
        
        cmd1 = "%s/%s adj=1 naxis=%s eps=%s infile=%siter%s.H outfile=%siter%s.H >/dev/null "%(sbin,Rname, modax, EPS, dirrrm,iter,dmm,iter)
        os.system(cmd1)


	# -----------------------------------------------------------
        #---- Run the jobs  -----------------------------------------
        # -----------------------------------------------------------
        for i in range(1,len(K)+1):
        	shot = K[i-1]
		os.system("sleep 2")
		jobnameInd = jobname+'_%s'%(shot)	
		print 'Adjoint: submitting job #', jobnameInd
		stg1 = '%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s &'%(jobscpt,shot,jobnameInd, iter, outdir,projdir,plet, velfile, parfile, smooth, lpfil, VDer, gauss, DW, nhx, MWfile, DWfile)
		print stg1
		os.system(stg1)
	
	# Something that check jobs
	checkjob(jobname,projdir,outdir,dm,iter,K)		
	 			
	return


#############################################################################

def Forward(maindir, projdir, velfile, parfile, plet, K, smooth, lpfil, VDer, gauss, DW, MWfile, DWfile, Rname, eps,ratio, modax, nhx, iter):

	jobname = "For%siter%s"%(plet,iter)
	jobscpt = maindir + '/pyinv1/pyForwardOneDir.py'
	outdir = projdir + '/gg'
	dirdm = projdir+"/dm/dmArt"+plet
	dirggm = projdir+'/ggm/ggmArt'+plet	
	dirgg = projdir+'/gg/ggArt'+plet	

	os.system('rm %s/JN/JNFor%siter%s.txt'%(projdir,plet,iter))
	# -----------------------------------------------------------
        #---- First, calculate ggm - eps A dm  ----------------------
        # -----------------------------------------------------------
        # Set ramping of the eps from zero to maxeps over 5 iterations
        ramp=[0.2,0.4,0.6,0.8,1.0]
        
        if iter <= len(ramp):
        	EPS = ramp[iter-1]*eps*ratio
        else:
        	EPS = eps*ratio
                        
        os.system('rm -f '+projdir+'/Epsilon.txt')
        if iter == 2:
		file = open(projdir+"/ResidualData.txt","w")
		cmd1 = "Iter ramp eps ratio EPS \n"
		file.writelines(cmd1);
	else:
		file = open(projdir+"/ResidualData.txt","a")
		
	cmd2 = "%s %s %s %s %s \n"%(iter, ramp[min(iter-1,len(ramp)-1)],eps,ratio,EPS)
	file.writelines(cmd2);
	file.close()
        
        cmd1 = "%s/%s adj=0 naxis=%s eps=%s infile=%sTotaliter%s.H outfile=%siter%s.H >/dev/null"%(sbin,Rname, modax, EPS, dirdm,iter,dirggm,iter)
	#print cmd1
        os.system(cmd1)

	# -----------------------------------------------------------
        #---- Run the jobs  -----------------------------------------
        # -----------------------------------------------------------
	for i in range(1,len(K)+1):
		shot=K[i-1]
		os.system("sleep 2")	
		jobnameInd=jobname+"_%s"%(shot)	
		print 'Forward: submitting shot #', jobnameInd
		stg1 = '%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s &'%(jobscpt,shot,jobnameInd, iter, outdir,projdir,plet, velfile, parfile, smooth, lpfil, VDer, gauss, DW, nhx, MWfile, DWfile)
		#print stg1
		os.system(stg1)

	# Something that check jobs
	checkjob(jobname,projdir,outdir,dirgg,iter,K)		


	 			
	return


# ####################################


def Add(maindir,projdir, d1,  iter, naxis, plet,dmm):
	# naxis: number of axes in files to be summed
        d1BK=d1+"BK"
	outdir = projdir+'/dm'

	scpt = 'pyinv1/pyAddrtm.py'
	stg1 = '%s %s %s %s %s %s %s'%(scpt,outdir,d1,iter,naxis,plet,dmm)
	print stg1
	os.system(stg1)

	#wait for job to finish (have the exact same jobname as specified in pyAddrtm.py'
	jobname='Add%s%s'%(plet,iter)
	waitforjob(jobname,outdir,1800)
	
		# Now check if final output file exist
	# If so, erase all intermediate outputs (except for a selected few)
	searchname = "%sTotaliter%s.H"%(d1,iter)
	print 'searching for filename:', searchname
	lenn = len(searchname)
	os.system("${SEPBIN}/In %s | grep \"in=\" >> %s/CKoutTotaliter%s.txt"%(searchname, outdir,iter))
	file = open("%s/CKoutTotaliter%s.txt"%(outdir,iter))
	line = file.readline()
	pos=line.find("in=")
	binaryfile = line[pos+3:len(line)-1]
	#print "binary", binaryfile
	os.system('rm -r %s/CKoutTotaliter%s.txt'%(outdir,iter))
	if (not os.path.exists(binaryfile)):
		stg2 = 'Add rtm : plet %s iter %s not done'%(plet,iter)
		sys.exit('Add rtm files failed, exit')

#	# Start erasing intermediate files
#	print 'len EK'
#	for i in EK[:]:
#        	cmd1 = 'python pycode/pyRemove.py %s%siter%s.H'%(d1,i,iter)
#		os.system(cmd1)

	
	return
           	  	  	  	
	

# ####################################	
# Calculate the alpha only using double precision

def DPcalCG(projdir, plet,iter,datax, modax, dirdm, dirggm, dirgg, dirrr, dirrrm):

	cmdfile ='%s/pbs/DPcalCGiter%s.txt'%(projdir,iter)
	logfile = '%s/pbs/logfile'%(projdir)
	jobname = 'DP%s_%s'%(plet,iter)

	os.system('rm -f %s'%(cmdfile))
	cmd1 = 'python pyinv1/pyDPcalCG.py %s %s %s %s %s %s %s %s %s %s'%(projdir,plet,iter,datax,modax,dirdm,dirggm,dirgg,dirrr,dirrrm)
	os.system("echo '%s' >> %s"%(cmd1,cmdfile))

	# Submit job and wait until it is done
	cmd1 = "pycode/pyWritePBS.py %s %s %s %s %s %s"%(1,8,'24:00:00','2gb',jobname,cmdfile)
	os.system( cmd1)
	waitforjob(jobname,logfile,1800)

	# initialize alpha and beta
	alpha=0.
	beta=0.

	# read the alpha values
        f = open(projdir+"/alpha.txt")
        alpha = float(f.readline())
        beta = 0.
        f.close()
	os.system('rm -f %s/alpha.txt'%(projdir))

	return alpha, beta

# ####################################	
# Calculate the alpha and beta using double precision

def DPcalCD(projdir, plet,iter,datax,modax, dirdm, dirggm, dirgg, dirrr, dirrrm, dirss, dirssm):

	cmdfile ='%s/pbs/DPcalCDiter%s.txt'%(projdir,iter)
	logdir = '%s/pbs/logfile'%(projdir)
	jobname = 'DP%s_%s'%(plet,iter)

	os.system('rm -f %s'%(cmdfile))
	cmd1 = 'python pyinv1/pyDPcalCD.py %s %s %s %s %s %s %s %s %s %s %s %s'%(projdir,plet,iter,datax,modax,dirdm,dirggm,dirgg,dirrr,dirrrm,dirss,dirssm)
	os.system("echo '%s' >> %s"%(cmd1,cmdfile))

	# Submit job and wait until it is done
	cmd1 = "pycode/pyWritePBS.py %s %s %s %s %s %s"%(1,8,'24:00:00','2gb',jobname,cmdfile)
	os.system( cmd1)
	waitforjob(jobname,logdir,1800)

	# initialize alpha and beta
	alpha=0.
	beta=0.

        # Read the alpha and beta values
	f = open(projdir+"/alpha.txt")
	alpha = float(f.readline())
	beta  = float(f.readline())
	f.close()	
	os.system("rm -f "+projdir+"/alpha.txt")

	return alpha, beta


# ####################################
def ResidCal(projdir, plet, K,iter,datax, dirrr):
	resid = 0.
	for i in K[:]:
		shot = i
		# calculating rrdrr
		os.system('rm -f '+projdir+'/temp.txt')
		cmd1 = "%s/Solver_ops.x cg=1 naxis=%s file1=%s%siter%s.H outfile=%s/temp.txt >&/dev/null"%(sbin,datax,dirrr,shot,iter,projdir)
		print cmd1
		os.system(cmd1)	
		f2 = open(projdir+'/temp.txt', 'r')
		str1 = f2.readline()
		resid = resid + float(str1)
		
	return resid
# ###################################

def removefiles(maindir,nblock,dboc,iter,nitersave,saveshot,plet):
	d1BK = maindir +"/dm/dmKBB"
	dirgg = maindir + "/gg/ggArt%s"%(plet)
	dirss = maindir + "/ss/ssArt%s"%(plet)
	dirrr = maindir + "/rr/rrArt%s"%(plet)
	dirs  = maindir + "/s/sArt%s"%(plet)
	dirm  = maindir + "/m/mArt%s"%(plet)
	dirdm = maindir + "/dm/dmArt%s"%(plet)
	os.system("rm -f "+maindir+"/alpha.txt")
	
	for i in K[:]:
		shot = i
		# Erase all the dmD%.H file after each BK is calculated
  		os.system("pycode/pyRemove.py "+dirdm+`shot`+"iter"+`iter`+".H ") 

  	# Erase all the dmDBK%.H file after Total is calculated
		os.system("pycode/pyRemove.py "+d1BK+"*.H")

	
	# Erase old rr, gg, and ss, unless request to be saved    
#	for i in range(1,(nblock-1)*dboc+1):
#		shot = 
#		os.system("pycode/pyRemove.py "+dirgg+`shot`+"iter"+`iter`+".H ")
#		os.system("pycode/pyRemove.py "+dirss+`shot`+"iter"+`iter`+".H ")
#		if ((iter%nitersave == 0) & (shot != saveshot)):
#			os.system("pycode/pyRemove.py "+dirrr+`shot`+"iter"+`iter`+".H ")
	
	# Erase old m, dm, and s
#	os.system("pycode/pyRemove.py "+dirs+"Total"+"iter"+`iter`+".H ")
#	if (iter%nitersave == 0):
#		os.system("pycode/pyRemove.py "+dirm+"Total"+"iter"+`iter`+".H "+dirdm+"Total"+"iter"+`iter`+".H ")
			
	return		
