#! /usr/bin/env python
#from SEP import *
import commands as cmd
import re,string
import sys, os
import os.path as path


import pyInvmodRegOneDir
sbin = "./Bin"



def run(maindir,projdir,velfile,parfile, plet,K,UD,nmz,omz,dmz,nmx,omx,dmx,nmy,omy,dmy,nhx,modax,datax, dirdata, smooth,lpfil,VDer,gauss,DW,souwfld,MWfile, DWfile, Rname,eps,ratio):
	dirm = projdir + "/m/mDei"+plet
	dirdm = projdir + "/dm/dmDei"+plet
	dirs = projdir + "/s/sDei"+plet
	dirgg = projdir + "/gg/ggDei"+plet
	dirss = projdir + "/ss/ssDei"+plet
	dirrr = projdir + "/rr/rrDei"+plet
	dirrrm = projdir + "/rrm/rrmDei"+plet
	dirssm = projdir + "/ssm/ssmDei"+plet
	dirggm = projdir + "/ggm/ggmDei"+plet
	dmm    = projdir + '/dm/dmMDei'+plet

	cmdfile = '%s/pbs/firstPart%s.txt'%(projdir,plet)
	jobname = 'Pre%s_1'%(plet)
	logdir = '%s/pbs/logfile'%(projdir)
	os.system('rm -f %s'%(cmdfile))

	# Step 0: Create initial model
	cmd0='python pycode/pyRemove.py %sTotaliter1.H'%(dirm)
	cmd1 = "%s/myZero.x naxis=4 n1=%s n2=%s n3=%s n4=%s o1=0. o2=0. o3=0. o4=0. d1=1. d2=1. d3=1. d4=1. > %sTotaliter1.H"%(sbin,nmz,nmx,nmy,2*nhx+1,dirm)	

	cmd2 ="echo 'o1=%s o2=%s o3=%s o4=%s d1=%s d2=%s d3=%s d4=%s label1=z label2=x label3=y label4=hx' >> %sTotaliter1.H"%(omz,omx,omy,-nhx*dmx,dmz,dmx,dmy,dmx,dirm)
	os.system("echo '%s' >> %s"%(cmd0,cmdfile))
	os.system("echo '%s' >> %s"%(cmd1,cmdfile))
	os.system("echo '%s' >> %s"%(cmd2,cmdfile))


	# Step 1: Copy all data into /rr/ 
	for i in K[:]:
		if (DW):
			#  rrd = - Wd
			C1 = "%s/ApplyWgt3D.x <%s/%s%s.H Wgtfile=%s/%s%s.H outfile=%s/t1%s%s.H >/dev/null"%(sbin, maindir, dirdata, i, maindir, DWfile, i,projdir, plet,i)
			C2 = "%s/updateAB.x alpha=-1. cg=1 naxis=%s file1=%s/t1%s%s.H outfile=%s%siter1.H >/dev/null"%(sbin,datax,projdir,plet,i,dirrr,i)
			C3 ='python pycode/pyRemove.py %s/t1%s%s.H'%(projdir,plet,i)
			os.system("echo '%s' >> %s"%(C1,cmdfile))
			os.system("echo '%s' >> %s"%(C2,cmdfile))
			os.system("echo '%s' >> %s"%(C3,cmdfile))

		else:		
			C1 = "%s/updateAB.x alpha=-1. cg=1 naxis=%s file1=%s/%s%s.H outfile=%s%siter1.H >/dev/null"%(sbin,datax,maindir,dirdata,i,dirrr,i)
			os.system("echo '%s' >> %s"%(C1,cmdfile))


	# Step 1b: rrm = 0.
	cmd1 = 'cp %sTotaliter1.H %siter1.H '%(dirm,dirrrm)
	os.system("echo '%s' >> %s"%(cmd1,cmdfile))

	# Submit and check above jobs
        cmd1 = "pycode/pyWritePBSsep.py %s %s %s %s %s%s %s"%(1,8,'24:00:00','2gb',jobname,i,cmdfile)
	os.system( cmd1)
	pyInvmodRegOneDir.waitforjob(jobname,logdir,1800)
	

        #Step 2: Run adjoint to calculate dm
	pyInvmodRegOneDir.Adjoint(maindir, projdir, velfile, parfile, plet, UD, smooth, lpfil,VDer, gauss, DW, souwfld, MWfile, DWfile, Rname, eps, ratio, modax, nhx, 1) 
	pyInvmodRegOneDir.Add(maindir,projdir,dirdm, 1, modax, plet,dmm,dirdm)
	
       # Step 3: Split the updates into 2 files
	C1="%s/offsetmask.x < %sSUMiter%s.H vel=6. zmute=100. outfile1=%sTotaliter%s.H >/dev/null"%(sbin,dirdm,1,dirdm,1)
	C2= 'echo "label1=z label2=x label3=y label4=hx" >> %sTotaliter%s.H '%(dirdm,1)
	os.system(C1)
	os.system(C2)
	
	# Step 4: Forward gg = Fdm, ggm= eps A dm        
	pyInvmodRegOneDir.Forward(maindir, projdir, velfile, parfile, plet, UD, smooth, lpfil, VDer, gauss, DW, souwfld, MWfile, DWfile, Rname, eps, ratio, modax, nhx, 1)
        	

	# Step 5: Calculate the alpha in Conjugate gradient
	alpha, beta = pyInvmodRegOneDir.DPcalCG(projdir,plet,1,datax, modax, dirdm, dirggm, dirgg, dirrr, dirrrm)	
	print 'alpha, beta', alpha, beta

	# Step 6: Update the model and data residual files
	pyInvmodRegOneDir.CGmodelupdate(alpha,projdir,plet,1,datax,modax,dirrr,dirgg,dirss,dirrrm,dirggm,dirssm,dirdm,dirm,dirs)



